//
//  AppsInfoUserAvatar.h
//  iSold_Apps
//
//  Created by Steve Sebban on 17/09/09.
//  Copyright 2009 KPL Production Services, Ltd.. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SaleInfoObject.h"
#import "NSDataGZipDecompressor.h"
#import <AudioToolbox/AudioServices.h>
#import <UIKit/UIKit.h>
 
@interface AppsInfoUserAvatar : NSObject {

	NSString *lastDateOfSales, *newLastDateOfSales;
	BOOL isCurrentConnectionRunning, didConnectionFinishLoading, viewUpdated;
	CFURLRef        soundFileURLRef;
    SystemSoundID    soundFileObject;
	NSDate *dateAndTimeLastChecked;

}

@property (readwrite, assign) NSString *lastDateOfSales;
@property (readwrite, assign) NSString *newLastDateOfSales;
@property (readwrite, assign) BOOL isCurrentConnectionRunning;
@property (readwrite, assign) BOOL didConnectionFinishLoading;
@property (readwrite, assign) BOOL viewUpdated;
@property (readwrite, assign) NSDate *dateAndTimeLastChecked;
@property (readwrite) CFURLRef soundFileURLRef;
@property (readonly) SystemSoundID soundFileObject;

- (AppsInfoUserAvatar *) initConnectionWithAppsInfo: (NSObject *) viewControlller andValidate: (BOOL) validationRequired;
- (void) updatePreferredCurrency;
- (void) processLogin;
- (NSDictionary *) summarizeSalesPerRegionForAppNumber: (int) item keepOriginalRC: (BOOL) kORC;
- (NSArray *) regionFlagsFileNames;
- (UIImage *) imageOfAppNumber:(int)item;
- (NSString *) nameOfAppNumber:(int)item;
- (NSArray *) dailyDataPerProduct: (int)item;
- (void) downloadAndExtractConversionRateFromCSVFile: (NSURL *)sentURLString;

@end
