//
//  AppsInfoUserAvatar.m
//  iSold_Apps
//
//  Created by Steve Sebban on 17/09/09.
//  Copyright 2009 KPL Production Services, Ltd.. All rights reserved.
//

#import "AppsInfoUserAvatar.h"


@implementation AppsInfoUserAvatar

@synthesize lastDateOfSales;
@synthesize newLastDateOfSales;
@synthesize isCurrentConnectionRunning;
@synthesize didConnectionFinishLoading;
@synthesize viewUpdated;
@synthesize dateAndTimeLastChecked;
@synthesize soundFileURLRef;
@synthesize soundFileObject;

NSString *urlString, *subText, *nameForLogin, *passwordForLogin, *partialHTMLBody, *wholeHTMLBody, *preferredCurrecy, *conversionRate, *websitePath, *salesReport, *recentURLAddress;
NSMutableArray *applicationsNames, *applicationsPicsURL, *applicationsPics, *applicationsPicsPaths, *salesObjects, *dataSummaryPerProduct, *regions, *SummaryOfLastestReport, *surfToSequence;
NSArray *partOfHTMLBody, *sortedRegions, *regionFlagsFileNames, *picsToDownload, *summary, *savedPlist, *savedSummary, *arrayOfNotifications;
NSObject *_ViewController;
NSURLConnection *currentConnection;
BOOL shouldValidateAccessDetails, blockAdditionOfSequences, logoutStarted, viewUpdated, newReportDownloaded;
int loggedOn, nextLoggedOnItem, loginFailureCounter;
NSData *gzfile;
NSThread *downloadThread1, *downloadThread2, *downloadThread3;
NSTimer *connectionFinishCheckTimer;
SaleInfoObject *salesObject;
NSMutableDictionary *countryToRegion;
SystemSoundID newReportSound;

- (AppsInfoUserAvatar *) initConnectionWithAppsInfo: (NSObject *) viewControlller andValidate: (BOOL) validationRequired {

	websitePath = [[NSString alloc] initWithString:@"https://itunesconnect.apple.com"];
	[self setIsCurrentConnectionRunning:NO];
	gzfile = [[NSData alloc] initWithData:nil];
	//logoutStarted = NO;
	loginFailureCounter = 0;
	blockAdditionOfSequences = NO;
	surfToSequence = [[NSMutableArray alloc] initWithCapacity:20];
	_ViewController = viewControlller;
	shouldValidateAccessDetails = validationRequired;
	newReportDownloaded = NO;
	NSURL *urlNewReportSound = [NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"Cash Register 1" ofType:@"aif"] isDirectory:NO];
	AudioServicesCreateSystemSoundID ((CFURLRef)urlNewReportSound, &newReportSound);

	[self getNameAndPasswordFromUserSettingObject];
	preferredCurrecy = [[NSString alloc] initWithString:[[_ViewController userSettingsObject] interfaceCurrency]];
	countryToRegion = [[NSMutableDictionary alloc] initWithCapacity:100];
	NSDictionary *dictionary = [_ViewController countryNamesAndRegions];
	if (dictionary!=nil) {
		[self populateCountryToRegionDictionary:dictionary];
		[self populateRegionImagesArray:dictionary];
	}
	[self setViewUpdated:NO];
	
	return self;
}

- (void) updatePreferredCurrency {
	preferredCurrecy = [[NSString alloc] initWithString:[[_ViewController userSettingsObject] interfaceCurrency]];
}

- (void) processLoadPreviousReportDetails {
	//NSLog(@"processLoadPreviousReportDetails");

	NSMutableArray *tempPlist;
	if ([self doesPreviousRecordExistOnDisk]) {
		NSString *fileName = [[NSString alloc] initWithString:@"SummaryOfLastestReport.plist"];
		NSString *directoryContents = [[NSString alloc] initWithFormat:@"%@/Documents/%@",NSHomeDirectory(),fileName];
		//NSLog(@"directoryContents = %@",directoryContents);
		NSData *data = [NSData dataWithContentsOfFile:directoryContents];
		NSString *error;
		NSPropertyListFormat format;
		id plist;
		plist = [NSPropertyListSerialization propertyListFromData:data mutabilityOption:NSPropertyListImmutable format:&format errorDescription:&error];
		if (!plist)
		{
			[error release];
		}
		else {
			applicationsNames = [[NSArray alloc] initWithArray:[plist objectAtIndex:0]];
			[self checkIfAppPicExistsInFolder];
			[self getPictures];
			savedPlist = [[NSArray alloc] initWithArray:plist];
			tempPlist = [[NSMutableArray alloc] initWithArray:plist];
			dateAndTimeLastChecked = [tempPlist lastObject];
			[tempPlist removeLastObject];
			NSArray *conversionRates = [[NSArray alloc] initWithArray:[tempPlist lastObject]];
			[tempPlist removeLastObject];
			[self setLastDateOfSales:[[NSString alloc] initWithString:[tempPlist lastObject]]];
			[tempPlist removeLastObject];
			//NSLog(@"processLoadPreviousReportDetails: lastDateOfSales = %@", lastDateOfSales);
			salesReport = [[NSString alloc] initWithContentsOfFile:[[NSString alloc] initWithFormat:@"%@/Documents/%@",NSHomeDirectory(),@"report.txt"] encoding:NSUTF8StringEncoding error:&error]; 
			[self extractSalesDataFrom:salesReport];
			if ([self viewUpdated]==YES) {
				//NSLog(@"[_ViewController setActivityWindowContentTo:4]");
				[_ViewController setActivityWindowContentTo:4];
				[self downloadAndExtractConversionRateFromCSVFile:nil];
			}
			else {
				int salesObjectsCount = [salesObjects count];
				for (int i=0;i<salesObjectsCount; i++) {
					[[salesObjects objectAtIndex:i] setCurrencyConversionRate:[conversionRates objectAtIndex:i]];
				}
			}
			savedSummary = [self summarizeAppSales];
			[_ViewController populateDailySalesViewWith:savedSummary];
			[_ViewController updateLastCheckedOn:dateAndTimeLastChecked];
			if ([self viewUpdated]==YES) {
				//NSLog(@"[_ViewController setActivityWindowContentTo:0]");
				[_ViewController setActivityWindowContentTo:0];
				[self createSummaryOfLatestReportWithDate:dateAndTimeLastChecked];
				[self saveDataOnDisk];

			}
		}
	}
	else {
		if ([[_ViewController tabBarController] selectedIndex]!=1) {
			[[_ViewController dateOfLastestSales] setText:@"No Previous Records"];
			[[_ViewController dateAndTimeLastChecked] setText:@"Never Checked"];
		}
	}
	applicationsPicsURL = [[NSMutableArray alloc] initWithCapacity:100];
	if ([self viewUpdated]==NO) {
		if ([[_ViewController userSettingsObject] checkAtLaunch]==YES && [_ViewController checkNetworkAvailibility]) {
			[self processLogin];
		}
		else {
			[_ViewController clearNotificationTextAndBringRefreshBarToFront];
			//NSLog(@"Refresh Bar Should be in Front");
		}
	}
	else if ([self viewUpdated]==YES) [self setViewUpdated:NO];
}

- (void) processLogin {
	//NSLog(@"processLogin");
	[_ViewController bringNotificationTextToFront];
	[self addSequenceAsLast:0 to:1];
	[self pullNextSequence];
	//NSLog(@"surfToSequence = %@", surfToSequence);
	//NSLog(@"loggedOn = %i",loggedOn);
	[self processFromLoginToObtainingLatestDate];
}

- (void) processFromLoginToObtainingLatestDate {
	//NSLog(@"processFromLoginToObtainingLatestDate");
	if (![_ViewController doesMessageExistInDispatchList:@"Webpage Download Completed"]) {
		[_ViewController addNotificationRequestFrom:self toOperate:@selector(hTMLDownloadCompleted) WithMessage:@"Webpage Download Completed"];
	}
	[_ViewController addNotificationRequestFrom:self toOperate:@selector(processDownloadingReport) WithMessage:@"Date of Last Report Obtained"];
	//NSLog(@"doesMessageExistInDispatchList: Webpage Download Completed = %@",[_ViewController doesMessageExistInDispatchList:@"Webpage Download Completed"]?@"YES":@"NO");
	//NSLog(@"displayNotificationCenterDispatchListObservers = %@", [_ViewController displayNotificationCenterDispatchListObservers]);
	//NSLog(@"displayNotificationCenterDispatchList = %@", [_ViewController displayNotificationCenterDispatchList]);
	[self requestToSurfTo: @"https://itunesconnect.apple.com"];
	[[_ViewController statusLabel] setText:@"Connecting"];

}

- (void) processDownloadingReport {
	//NSLog(@"processDownloadingReport");
	[_ViewController removeNotificationRequestFrom:self WithMessage:@"Date of Last Report Obtained"];

	if ([lastDateOfSales isEqualToString:newLastDateOfSales]) {
		[self processFromObtainingLastestDateToSaveLastCheckedData];
	}
	else {
		[self setLastDateOfSales:newLastDateOfSales];
		[[_ViewController statusLabel] setText:@"Downloading Latest Report"];
		
		[self startDownloadingInThreadFromURL: subText
								 withSelector:@selector(downloadReportFileFrom:) 
								  endTestWith:@selector(processUnzippingOfData)
								 threadNumber:&downloadThread1
						  endNotificationName:@"Report Downloaded"];
		
	}
}

- (void) processUnzippingOfData {
	//NSLog(@"processUnzippingOfData");
	[downloadThread1 cancel];
	[_ViewController removeNotificationRequestFrom:self WithMessage:@"Report Downloaded"];
	salesReport = [self decompressData: gzfile];
	[self saveString:salesReport ToFileNamed:@"report.txt"];
	//NSLog(@"saved Downloaded Report");
	newReportDownloaded = YES;
	[self processFromExtractionOfDataToGetAppURLs];
}

- (void) processFromExtractionOfDataToGetAppURLs {
	//NSLog(@"processFromExtractionOfDataToGetAppURLs");
	[self extractSalesDataFrom: salesReport];
	picsToDownload = [self checkIfAppPicExistsInFolder];
	if ([picsToDownload count]!=0) { 
		//NSLog(@"[picsToDownload count]!=0");
		[_ViewController addNotificationRequestFrom:self toOperate:@selector(processGetAppIcons) WithMessage:@"obtained all app pics URLs"];
		[self addSequenceAsLast:5 to:7];
		[self pullNextSequence];
		[self hTMLDownloadCompleted];
	}
	else [self processGetAppIcons];
}

- (void) processGetAppIcons {
	//NSLog(@"processGetAppIcons");
	[[_ViewController statusLabel] setText:@"Getting App Icons"];
	[self startDownloadingInThreadFromURL:nil 
							 withSelector:@selector(getPictures) 
							  endTestWith:@selector(processFromExtractionOfDataToPopulationOfView) 
							 threadNumber:&downloadThread3 
					  endNotificationName:@"App Icons Downloaded"];
}

- (void) processFromExtractionOfDataToPopulationOfView {
	//NSLog(@"processFromExtractionOfDataToPopulationOfView");
	[_ViewController removeNotificationRequestFrom:self WithMessage:@"App Icons Downloaded"];
	[self startDownloadingInThreadFromURL:nil 
							 withSelector:@selector(downloadAndExtractConversionRateFromCSVFile:) 
							  endTestWith:@selector(processFromPopulationOfViewToSaveLastCheckedData)
							 threadNumber:&downloadThread2
					  endNotificationName:@"Currencies Coversions Downloaded"];
}

- (void) processFromPopulationOfViewToSaveLastCheckedData {
	//NSLog(@"processFromPopulationOfViewToSaveLastCheckedData");
	[downloadThread2 cancel];
	[_ViewController removeNotificationRequestFrom:self WithMessage:@"Currencies Coversions Downloaded"];
	summary = [self summarizeAppSales];
	NSDate *todayAndNow = [NSDate date];
	[self createSummaryOfLatestReportWithDate:todayAndNow];
	[_ViewController populateDailySalesViewWith:summary];
	if (newReportDownloaded) {
		
		AudioServicesPlaySystemSound(newReportSound);
		// Get the main bundle for the app
		CFBundleRef mainBundle;
		mainBundle = CFBundleGetMainBundle ();
		
		// Get the URL to the sound file to play
		soundFileURLRef  =    CFBundleCopyResourceURL (
													   mainBundle,
													   CFSTR ("tap"),
													   CFSTR ("aif"),
													   NULL
													   );
		
		// Create a system sound object representing the sound file
		AudioServicesCreateSystemSoundID (
										  soundFileURLRef,
										  &soundFileObject
										  );
		
		AudioServicesPlaySystemSound (kSystemSoundID_Vibrate);
	}
	newReportDownloaded = NO;
	[self processFromSaveLastCheckedDataToSignOut];
}

- (void) processFromObtainingLastestDateToSaveLastCheckedData {
	//NSLog(@"processFromObtainingLastestDateToSaveLastCheckedData");
	NSDate *todayAndNow = [NSDate date];
	[_ViewController updateLastCheckedOn:todayAndNow];
	SummaryOfLastestReport = [[NSMutableArray alloc] initWithArray:savedPlist];
	[SummaryOfLastestReport replaceObjectAtIndex:[SummaryOfLastestReport count]-1 withObject:todayAndNow];
	[self processFromSaveLastCheckedDataToSignOut];
}

- (void) processFromSaveLastCheckedDataToSignOut {
	//NSLog(@"processFromSaveLastCheckedDataToSignOut");
	[self saveDataOnDisk];
	[[_ViewController statusLabel] setText:@"Logging Out"];
	[self logOut];

}

- (void) saveDataOnDisk {
	NSString *error;
	NSData *xmlData = [NSPropertyListSerialization dataFromPropertyList:SummaryOfLastestReport format:kCFPropertyListXMLFormat_v1_0 errorDescription:&error]; 
	NSString *fileName = [[NSString alloc] initWithString:@"SummaryOfLastestReport.plist"];
	NSString *directoryContents = [[NSString alloc] initWithFormat:@"%@/Documents/%@",NSHomeDirectory(),fileName]; 
	NSFileManager *fileManager = [NSFileManager defaultManager];
	if (![fileManager fileExistsAtPath: directoryContents]) {
		[fileManager createFileAtPath:directoryContents contents:nil attributes:nil];
	}
	[xmlData writeToFile:directoryContents atomically:YES];	
}

- (void) createSummaryOfLatestReportWithDate: (NSDate *) date {
	SummaryOfLastestReport = [[NSMutableArray alloc] initWithCapacity:100];
	[SummaryOfLastestReport addObject:applicationsNames];
	[SummaryOfLastestReport addObject:lastDateOfSales];
	int salesObjectsCount = [salesObjects count];
	NSMutableArray *coversionRates = [[NSMutableArray alloc] initWithCapacity:100];
	for (int i=0; i<salesObjectsCount; i++) {
		[coversionRates addObject:[[salesObjects objectAtIndex:i] currencyConversionRate]];
	}
	//NSLog(@"coversionRates = %@", coversionRates);

	[SummaryOfLastestReport addObject:coversionRates];
	[_ViewController updateLastCheckedOn:date];
	dateAndTimeLastChecked = [date copy];
	[SummaryOfLastestReport addObject:date];
	
}

- (BOOL) doesPreviousRecordExistOnDisk {
	//NSLog(@"doesPreviousRecordExistOnDisk");
	NSFileManager *fileManager = [NSFileManager defaultManager];
	NSString *fileName = [[NSString alloc] initWithString:@"SummaryOfLastestReport.plist"];
	NSString *directoryContents = [[NSString alloc] initWithFormat:@"%@/Documents/%@",NSHomeDirectory(),fileName]; 
	NSError *error;
	NSString *tempSalesReport = [[NSString alloc] initWithContentsOfFile:[[NSString alloc] initWithFormat:@"%@/Documents/%@",NSHomeDirectory(),@"report.txt"] encoding:NSUTF8StringEncoding error:&error]; 
	if (![fileManager fileExistsAtPath: directoryContents] || [tempSalesReport length]==0) return NO;
	else return YES;
	return NO;
}

#pragma mark Connection Handling

- (void) surfTo: (NSString *) urlSent {
	//NSLog(@"surfTo");
	NSURL *url = [NSURL URLWithString: urlSent];
	
	NSURLRequest *request = [[NSURLRequest alloc] initWithURL:url cachePolicy:NSURLRequestReloadIgnoringLocalAndRemoteCacheData timeoutInterval:50.0];
	currentConnection = [[NSURLConnection alloc] initWithRequest:request delegate:self];
	
	[request release];
	[self setDidConnectionFinishLoading:NO];

}


-(NSURLRequest *)connection:(NSURLConnection *)connection willSendRequest:(NSURLRequest *)request redirectResponse:(NSURLResponse *)redirectResponse
{
	//NSLog(@"connection: willSendRequest: redirectResponse:");
	NSString *temp = [[NSString alloc] initWithFormat:@"%@",[request URL]];
	if ([temp isEqualToString:@"https://itts.apple.com/"]) request = [[NSURLRequest alloc] initWithURL:[NSURL URLWithString:@"https://itts.apple.com/cgi-bin/WebObjects/Piano.woa"]];
	NSURLRequest *newRequest=request;
	return newRequest;
}

- (void) connectionDidFinishLoading: (NSURLConnection*) connection {
	//NSLog(@"connectionDidFinishLoading");
	[self setDidConnectionFinishLoading:YES];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"Webpage Download Completed" object:self];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"Connection Completed Download" object:self];
	//NSLog(@"NotificationCenter = %@", [NSNotificationCenter defaultCenter]);
	//NSLog(@"connectionDidFinishLoading: End");
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	//NSLog(@"connection: didReceiveData:");

	if (data!=NULL){

		partialHTMLBody = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
		
		NSRange rangeUntilHTML = [partialHTMLBody rangeOfString:@"</HTML>"];
		NSRange rangeUntilhtml = [partialHTMLBody rangeOfString:@"</html>"];
		BOOL notFindHTML = NSEqualRanges(rangeUntilHTML, NSMakeRange(NSNotFound, 0));
		BOOL notFindhtml = NSEqualRanges(rangeUntilhtml, NSMakeRange(NSNotFound, 0));
		
		if (notFindHTML && notFindhtml) {
			//NSLog(@"connection: didReceiveData: notFindHTML && notFindhtml");
			wholeHTMLBody = [[NSString alloc] initWithFormat:@"%@\n%@", wholeHTMLBody, partialHTMLBody];
			partialHTMLBody = @"";
			
		}
		else if (loggedOn>=0 && loggedOn<=99) {
			wholeHTMLBody = [[NSString alloc] initWithFormat:@"%@\n%@", wholeHTMLBody, partialHTMLBody];
		}
	}

}

- (void) hTMLDownloadCompleted {
	//NSLog(@"hTMLDownloadCompleted");
	
	if (loggedOn==0) {
		//NSLog(@"0");
		[self setIsCurrentConnectionRunning:YES];
		//NSLog(@"isCurrentConnectionRunning = %@",isCurrentConnectionRunning?@"YES":@"NO");
		subText = [self subStringStartingWith:@"form name=\"appleConnectForm\"" cutFromFirstInstanceOf:@"action=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		
		//NSLog(@"hTMLDownloadCompleted: loginFailureCounter = %i",loginFailureCounter);
		
		if ([subText isEqualToString:@"AppsInfoUserAvatar subStringStartingWith: substring not found in original string"] && loginFailureCounter<3) {
			//NSLog(@"hTMLDownloadCompleted: loginFailureCounter++: wholeHTMLBody = %@", wholeHTMLBody);
			[[_ViewController statusLabel] setText:@"Login Failed, Refreshing"];
			loginFailureCounter++;
			[self requestToSurfTo: [[NSString alloc] initWithFormat:@"https://itunesconnect.apple.com"]];
		}
		else if (loginFailureCounter==3) {
			loginFailureCounter=0;
			[[_ViewController statusLabel] setText:@"An Error Occurred, Please Refresh"];
			[self logOut];
		}
		else {
			//NSLog(@"Login Succeded");
			loginFailureCounter=0;
			[self requestToSurfTo: [[NSString alloc] initWithFormat:@"https://itunesconnect.apple.com%@?theAccountName=%@&theAccountPW=%@", subText,nameForLogin, passwordForLogin]];
			[[_ViewController statusLabel] setText:@"Logging In"];
			[self pullNextSequence];
		}
	}
	else if (loggedOn==1) {
		//NSLog(@"1");

		subText = [self subStringStartingWith:@"Sales and Trend" cutFromFirstInstanceOf:@"href=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		BOOL substringFound = ![subText isEqualToString:@"AppsInfoUserAvatar subStringStartingWith: substring not found in original string"];
		NSString *subText2 = [self subStringStartingWith:@"class=\"footerLinks\"" cutFromFirstInstanceOf:@"href=\"" endCutWhenFinding:@"\">Sign Out" inString:wholeHTMLBody];
		BOOL signOutFound = ![subText2 isEqualToString:@"AppsInfoUserAvatar subStringStartingWith: substring not found in original string"];

			if (shouldValidateAccessDetails) {
				if (!substringFound && !signOutFound) {
					
					[_ViewController validationResult:NO];
					[self logOut];
					
				}
				else if ((!substringFound && signOutFound) || substringFound) {
					
					[_ViewController validationResult:YES];					
					NSArray *subTextLinks = [subText2 componentsSeparatedByString:@"<a href=\""];
					subText2 = [subTextLinks lastObject];
					[self addSequenceAsLast:9];
					[self pullNextSequence];
					 //NSLog(@"%@",[[NSString alloc] initWithFormat:@"https://itunesconnect.apple.com%@", subText2]);
					[self requestToSurfTo: [[NSString alloc] initWithFormat:@"https://itunesconnect.apple.com%@", subText2]];
					
				}
				
			}
			else if (!shouldValidateAccessDetails)	{	
				if (!substringFound && !signOutFound) {
					[[_ViewController statusLabel] setText:@"Problem occurred, Refreshing"];
					[_ViewController refreshButtonPressed:nil];
					
				}
				else if (!substringFound && signOutFound) {
					//[_ViewController unexpectedPage];
					
					//TEMP PATCH
					
					NSString *subText1 = [self subStringStartingWith:@"<form name=\"mainForm\"" cutFromFirstInstanceOf:@"action=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
					NSString *subText2 = [self subStringStartingWith:@"<input align" cutFromFirstInstanceOf:@"name=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
					[self requestToSurfTo:[[NSString alloc] initWithFormat:@"https://itunesconnect.apple.com%@?%@.x=1&%@.y=1", subText1, subText2, subText2]];
					 
					//END OF TEMP PATCH
				}
				else if (substringFound) {
					[self requestToSurfTo: [[NSString alloc] initWithFormat:@"https://itunesconnect.apple.com%@", subText]];
					//[[_ViewController statusLabel] setText:@"Getting App List"];
					[self addSequenceAsLast:2 to:4];	
					[self pullNextSequence];
				}
			}
		if (shouldValidateAccessDetails) shouldValidateAccessDetails=NO;
			
	}
	else if (loggedOn==2) {
		//NSLog(@"2");

		subText = [self subStringStartingWith:@"name=\"frmVendorPage\"" cutFromFirstInstanceOf:@"action=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		
		[self requestToSurfTo: [[NSString alloc] initWithFormat:@"https://itts.apple.com%@", subText]];
		[[_ViewController statusLabel] setText:@"Checking Reports Dates"];
		
		[self pullNextSequence];
		
	}
	else if (loggedOn==3) {
		//NSLog(@"3");
		NSString *subText2, *subText3, *subText4;
		
		subText = [self subStringStartingWith:@"name=\"frmVendorPage\"" cutFromFirstInstanceOf:@"action=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		
		subText2 = [self subStringStartingWith:@"onchange=\"handleSelReportType()\"" cutFromFirstInstanceOf:@"name=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		
		subText3 = [self subStringStartingWith:@"onchange=\"handleSelDateType()\"" cutFromFirstInstanceOf:@"name=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		
		subText4 = [self subStringStartingWith:@"name=\"frmVendorPage\"" cutFromFirstInstanceOf:@"/wo/" endCutWhenFinding:@"/" inString:wholeHTMLBody];
		
		[self requestToSurfTo: [[NSString alloc] initWithFormat:@"https://itts.apple.com%@?%@=Summary&%@=Daily&hiddenDayOrWeekSelection=Daily&hiddenSubmitTypeName=ShowDropDown&wosid=%@", subText, subText2, subText3, subText4]];
		
		[self pullNextSequence];
		
		
	}
	else if (loggedOn==4) {
		//NSLog(@"4");

		NSString *subText2, *subText3, *subText4, *subText5, *subText6;
		NSRange range, range2, range3;
		
		subText = [self subStringStartingWith:@"name=\"frmVendorPage\"" cutFromFirstInstanceOf:@"action=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		//NSLog(@"4. Checkpoint subText OK");

		subText2 = [self subStringStartingWith:@"onchange=\"handleSelReportType()\"" cutFromFirstInstanceOf:@"name=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		//NSLog(@"4. Checkpoint subText2 OK");

		subText3 = [self subStringStartingWith:@"onchange=\"handleSelDateType()\"" cutFromFirstInstanceOf:@"name=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		//NSLog(@"4. Checkpoint subText3 OK");

		@try {
			range = [wholeHTMLBody rangeOfString:@"<select Id=\"dayorweekdropdown\""];
			if (NSEqualRanges(range, NSMakeRange(NSNotFound, 0))) {
				[self setNewLastDateOfSales:lastDateOfSales];
			}
			else {
				
				subText4 = [wholeHTMLBody substringFromIndex:range.location];
				range = [subText4 rangeOfString:@"name=\""];
				if (NSEqualRanges(range, NSMakeRange(NSNotFound, 0))) {
					[self setNewLastDateOfSales:lastDateOfSales];
				}
				else {
					subText4 = [subText4 substringFromIndex:range.location+range.length];
					subText5 = [[NSString alloc] initWithString:subText4];
					range2 = [subText4 rangeOfString:@"\""];
					range3 = NSMakeRange(0, range2.location);
					subText4 = [subText4 substringWithRange: range3];
					
					range = [subText5 rangeOfString:@"option value=\""];
					if (NSEqualRanges(range, NSMakeRange(NSNotFound, 0))) {
						[self setNewLastDateOfSales:lastDateOfSales];
					}
					else {
						subText5 = [subText5 substringFromIndex:range.location+range.length];
						range2 = [subText5 rangeOfString:@"\""];
						range3 = NSMakeRange(0, range2.location);
						subText5 = [subText5 substringWithRange: range3];
						
						if ([[subText5 componentsSeparatedByString:@"/"] count]!=3) {
							[self setNewLastDateOfSales:lastDateOfSales];
						}
						else {
							
							subText6 = [self subStringStartingWith:@"name=\"frmVendorPage\"" cutFromFirstInstanceOf:@"/wo/" endCutWhenFinding:@"/" inString:wholeHTMLBody];
							
							[self setNewLastDateOfSales:[[NSString alloc] initWithString:subText5]];
							//NSLog(@"surfToSequence = %@", surfToSequence);
							
							[self pullNextSequence];
							subText = [[NSString alloc] initWithFormat:@"https://itts.apple.com%@?%@=Summary&%@=Daily&%@=%@&hiddenDayOrWeekSelection=%@&hiddenSubmitTypeName=Download&wosid=%@", subText, subText2, subText3, subText4, subText5, subText5, subText6];
						}
					}
				}
			}
		}
		@catch (NSException * e) {
			[self setNewLastDateOfSales:lastDateOfSales];
		}
		@finally {
			[[NSNotificationCenter defaultCenter] postNotificationName:@"Date of Last Report Obtained" object:nil];
		}

	}

	else if (loggedOn==5) {
		//NSLog(@"5");

		subText = [self subStringStartingWith:@"class=\"footerLinks\"" cutFromFirstInstanceOf:@"href=\"" endCutWhenFinding:@"\">Home" inString:wholeHTMLBody];
		
		//NSLog(@"https://itts.apple.com%@",subText);
		[self requestToSurfTo: [[NSString alloc] initWithFormat:@"https://itts.apple.com%@", subText]];
				
		[self pullNextSequence];
		
	}
	
	else if (loggedOn==6) {
		//NSLog(@"6");
		//NSLog(@"wholeHTMLBody = %@", wholeHTMLBody);
		subText = [self subStringStartingWith:@"alt=\"Manage Your Applications\"" cutFromFirstInstanceOf:@"href=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		
		//NSLog(@"https://itunesconnect.apple.com%@",subText);
		[self requestToSurfTo: [[NSString alloc] initWithFormat:@"https://itunesconnect.apple.com%@", subText]];
		
		[self pullNextSequence];
	}
	
	else if (loggedOn==7) {
		//NSLog(@"7");

		[self extractAppPicURLFrom: wholeHTMLBody];
		
		subText = [self subStringStartingWith:@"class=\"footerLinks\"" cutFromFirstInstanceOf:@"href=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
		
		[self requestToSurfTo: [[NSString alloc] initWithFormat:@"https://itunesconnect.apple.com%@", subText]];
		
		[self pullNextSequence];
		
	}
	
	
	else if (loggedOn==9) {
		//NSLog(@"9");
		logoutStarted = YES;
		arrayOfNotifications = [[NSArray alloc] initWithObjects:@"Logout Completed", @"Webpage Download Completed", nil];
		//NSLog(@"arrayOfNotifications = %@",arrayOfNotifications);
		[_ViewController clearNotificationDispatchListExceptFor:arrayOfNotifications];
		//NSLog(@"displayNotificationCenterDispatchList = %@",[_ViewController displayNotificationCenterDispatchList]);
		//NSLog(@"Logout Completed:%i", [_ViewController doesMessageExistInDispatchList:@"Logout Completed"]);
		wholeHTMLBody = [[NSString alloc] initWithFormat:@"%@%@", wholeHTMLBody, partialHTMLBody];
		
		if ([recentURLAddress rangeOfString:@"itunesconnect"].location!=NSNotFound) {
			websitePath = [[NSString alloc] initWithString:@"https://itunesconnect.apple.com"];
		}
		else if ([recentURLAddress rangeOfString:@"itts"].location!=NSNotFound) {
			websitePath = [[NSString alloc] initWithString:@"https://itts.apple.com"];
		}
		//NSLog(@"websitePath = %@",websitePath);
		subText = [self subStringStartingWith:@"class=\"footerLinks\"" cutFromFirstInstanceOf:@"href=\"" endCutWhenFinding:@"\">Sign Out" inString:wholeHTMLBody];
		//NSLog(@"loggedOn==9: subText = %@", subText);
		if ([subText isEqualToString:@"AppsInfoUserAvatar subStringStartingWith: substring not found in original string"]) {
			//NSLog(@"footerLinks\" not found!");
			NSString *subText2 = [self subStringStartingWith:@"form name=\"appleConnectForm\"" cutFromFirstInstanceOf:@"action=\"" endCutWhenFinding:@"\"" inString:wholeHTMLBody];
			if ([subText2 isEqualToString:@"AppsInfoUserAvatar subStringStartingWith: substring not found in original string"]) {
				//NSLog(@"appleConnectForm\" not found!");
				[self addSequenceAsLast:9];
				[self pullNextSequence];
				//NSLog(@"9: surfTo: %@",[[NSString alloc] initWithFormat:@"%@",websitePath]);
				[self requestToSurfTo: [[NSString alloc] initWithFormat:@"%@",websitePath]];
			}
			else {
				//NSLog(@"appleConnectForm\" found!");
				[self addSequenceAsLast:99];
				[self pullNextSequence];
				[self hTMLDownloadCompleted];
			}

		}
		else {
			//NSLog(@"loggedOn==9 & footerLinks\" found!");
			subText = [[NSString alloc] initWithString:[[subText componentsSeparatedByString:@"href=\""] lastObject]];
			//NSLog(@"loggedOn==9: subText = %@", subText);
			[self addSequenceAsLast:99];
			[self pullNextSequence];
			//NSLog(@"websitePathsubText = %@%@", websitePath, subText);
			partialHTMLBody = @"";
			wholeHTMLBody = @"";
			[self requestToSurfTo: [[NSString alloc] initWithFormat:@"%@%@", websitePath, subText]];
			//[self hTMLDownloadCompleted];

		}
		
	}
	
	else if (loggedOn==99) {
		//NSLog(@"99");
		//NSLog(@"wholeHTMLBody = %@", wholeHTMLBody); 
		subText = [self subStringStartingWith:@"class=\"footerLinks\"" cutFromFirstInstanceOf:@"href=\"" endCutWhenFinding:@"\">Sign Out" inString:wholeHTMLBody];
		if (![subText isEqualToString:@"AppsInfoUserAvatar subStringStartingWith: substring not found in original string"]) {
			//NSLog(@"loggedOn==99: UNEXPECTED: footerLinks\" found!");
			[self addSequenceAsLast:9];
			[self pullNextSequence];
			[self hTMLDownloadCompleted];
		}
		else {
			[currentConnection release];

			partialHTMLBody = @"";
			wholeHTMLBody = @"";
			if (blockAdditionOfSequences) blockAdditionOfSequences = NO;
			[self setIsCurrentConnectionRunning:NO];
			if ([_ViewController doesMessageExistInDispatchList:@"Webpage Download Completed"]) {
				[_ViewController removeNotificationRequestFrom: self WithMessage: @"Webpage Download Completed"];
			}
			if ([_ViewController doesMessageExistInDispatchList:@"Logout Completed"]) {
				[[NSNotificationCenter defaultCenter] postNotificationName:@"Logout Completed" object:nil];
			}
			else [_ViewController clearNotificationTextAndBringRefreshBarToFront];
			logoutStarted = NO;
			[_ViewController removeNotificationRequestFrom:self WithMessage:@"Logout Completed"];
		}

	}
	
}


- (void) startDownloadingInThreadFromURL: (NSString *) downloadURLString 
							withSelector: (SEL) action 
							 endTestWith: (SEL) performOnEndOfThread
							threadNumber: (int *) memoryPointer 
					 endNotificationName: (NSString *) notificationName {

	*memoryPointer = [[NSThread alloc] initWithTarget:self selector:action object:downloadURLString];
	[*memoryPointer setName:downloadURLString];
	[*memoryPointer start];
	[_ViewController addNotificationRequestFrom:self toOperate:performOnEndOfThread WithMessage:notificationName];

}

- (void) reportDownloadedNotification: (NSString *) notificationName {
	[[NSNotificationCenter defaultCenter] postNotificationName:notificationName object:nil];
}

- (void) downloadReportFileFrom: (NSString *) sentURLString {
	NSAutoreleasePool *releasePool = [[NSAutoreleasePool alloc] init];
	NSError *error;
	NSURL *requestedURL = [[NSURL alloc] initWithString:sentURLString];
	gzfile = [[NSData alloc] initWithContentsOfURL:requestedURL options:NSUncachedRead error:error];
	[self performSelectorOnMainThread:@selector(reportDownloadedNotification:) withObject:@"Report Downloaded" waitUntilDone:NO];
	[releasePool drain];
}

- (void) downloadAndExtractConversionRateFromCSVFile: (NSURL *)sentURLString {
	//NSLog(@"downloadAndExtractConversionRateFromCSVFile");
	//NSLog(@"salesObject = %@",salesObject);
	//NSLog(@"preferredCurrecy = %@",preferredCurrecy);
	NSAutoreleasePool *releasePool2 = [[NSAutoreleasePool alloc] init];
	int salesObjectsCount = [salesObjects count];
	NSMutableArray *objectNumberForCurrencyRateUpdate = [[NSMutableArray alloc] initWithCapacity:50];
	NSMutableString *currencyExchangesText = [[NSMutableString alloc] initWithCapacity:100];
	NSMutableArray *currencyRateUpdate;
	for (int i=0; i<salesObjectsCount; i++) {
		salesObject = [salesObjects objectAtIndex:i];
		if ([[salesObject royaltyCurrency] isEqualToString:preferredCurrecy]) [salesObject setCurrencyConversionRate:@"1"];
		else {
			if ([objectNumberForCurrencyRateUpdate count]==0) {
				[currencyExchangesText appendFormat:@"%@%@=X",preferredCurrecy, [salesObject royaltyCurrency]];
				[objectNumberForCurrencyRateUpdate addObject:[[NSNumber alloc] initWithInt:i]];
			}
			else if ([objectNumberForCurrencyRateUpdate count]>0) {
				[currencyExchangesText appendFormat:@"+%@%@=X",preferredCurrecy, [salesObject royaltyCurrency]];
				[objectNumberForCurrencyRateUpdate addObject:[[NSNumber alloc] initWithInt:i]];
			}
		}
	}
	if ([currencyExchangesText isEqualToString:@""]) {
		//NSLog(@"did not download new currecy exchange rates");
	}
	else {
		conversionRate = [[NSString alloc] initWithContentsOfURL:[NSURL URLWithString:[[NSString alloc] initWithFormat:@"http://download.finance.yahoo.com/d/quotes.csv?e=.csv&f=l1&s=%@", currencyExchangesText]]];
		//NSLog(@"conversionRate = %@", conversionRate);
		currencyRateUpdate = [[NSMutableArray alloc] initWithArray:[conversionRate componentsSeparatedByCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]]];
		[currencyRateUpdate removeObject:@""];
		//NSLog(@"currencyRateUpdate = %@", currencyRateUpdate);
		int objectNumberForCurrencyRateUpdateCount = [objectNumberForCurrencyRateUpdate count];
		for (int i=0; i<objectNumberForCurrencyRateUpdateCount; i++) {
			[[salesObjects objectAtIndex:[[objectNumberForCurrencyRateUpdate objectAtIndex:i] intValue]] setCurrencyConversionRate: [currencyRateUpdate objectAtIndex:i]];
		}
	}
	//NSLog(@"salesObjects = \n%@",salesObjects);

	[self performSelectorOnMainThread:@selector(reportDownloadedNotification:) withObject:@"Currencies Coversions Downloaded" waitUntilDone:NO];
	[releasePool2 drain];
}

- (NSString *) decompressData: (NSData *) dataFile {

	NSDataGZipDecompressor *decompressor = [[NSDataGZipDecompressor alloc] initWithDataObject:dataFile];
	NSString *decompressedStringFile = [[NSString alloc] initWithData:[decompressor gzipInflate] encoding:NSUTF8StringEncoding];
	return decompressedStringFile;
}

- (void) saveString: (NSString *) text ToFileNamed: (NSString *) fileName {
	
	NSFileManager *fileManager = [NSFileManager defaultManager];
	NSString *directoryContents = [[NSString alloc] initWithFormat:@"%@/Documents/%@",NSHomeDirectory(),fileName]; 
	NSError *writeToFileError;
	[text writeToFile:directoryContents atomically:YES encoding:NSUTF8StringEncoding error:writeToFileError];
	
}

- (void) logOut {
	//NSLog(@"logOut");
	//NSLog(@"surfToSequence = %@",surfToSequence);

	if (!blockAdditionOfSequences) {
		//NSLog(@"NOT blockAdditionOfSequences");
		//NSLog(@"loggedOn = %i", loggedOn);
		//NSLog(@"loggedOn!=8 = %@", (loggedOn!=8)?@"Yes":@"No");
		//NSLog(@"loggedOn!=9 = %@", (loggedOn!=9)?@"Yes":@"No");
		//NSLog(@"loggedOn!=99 = %@", (loggedOn!=99)?@"Yes":@"No");
		if (loggedOn!=9 && loggedOn!=99) {
			[self addSequenceAsLast:9];
			while ([[surfToSequence objectAtIndex:0] intValue]!=9) {
				[surfToSequence removeObjectAtIndex:0];
			} 
			//NSLog(@"surfToSequence = %@",surfToSequence);

			blockAdditionOfSequences = YES;
			[self pullNextSequence];
			[self hTMLDownloadCompleted];	

		}
		else {
			if (logoutStarted) {
				//NSLog(@"logoutStarted");
			}
			else if (!logoutStarted) {
				//NSLog(@"NOT logoutStarted");
				if (![_ViewController doesMessageExistInDispatchList:@"Logout Completed"]) {
					[_ViewController addNotificationRequestFrom:self toOperate:@selector(hTMLDownloadCompleted) WithMessage:@"Logout Completed"];
				}
			}
		}

	}
	else {
		//NSLog(@"blockAdditionOfSequences");
	}
	
}


-(NSCachedURLResponse *)connection:(NSURLConnection *)connection willCacheResponse:(NSCachedURLResponse *)cachedResponse {
	return cachedResponse;
}

- (void) handleAuthenticationOKForChallenge: 
(NSURLAuthenticationChallenge *) aChallenge 
								   withUser: (NSString*) username 
								   password: (NSString*) password { 
	
}	

- (void)connection:(NSURLConnection *)connection didReceiveAuthenticationChallenge: (NSURLAuthenticationChallenge *)challenge {
	
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error{
}


- (void) cancelCurrentConnection {
	//NSLog(@"cancelCurrentConnection");
	[[_ViewController statusLabel] setText:@"Ending Previous Session"];

	[self performSelectorOnMainThread:@selector(bufferedCancelCurrentConnectionFunction) withObject:nil waitUntilDone:YES];
}

- (void) bufferedCancelCurrentConnectionFunction {
	//NSLog(@"bufferedCancelCurrentConnectionFunction");

	//NSLog(@"isCurrentConnectionRunning = %@",[self isCurrentConnectionRunning]?@"YES":@"NO");
	if ([self isCurrentConnectionRunning]) {
		[self logOut];
	}
	else if (![self isCurrentConnectionRunning]) {
		[[NSNotificationCenter defaultCenter] postNotificationName:@"Logout Completed" object:nil];
		//[_ViewController clearNotificationDispatchList];
	}
	
}

 
- (void) addSequenceAsLast: (int) lastSequence {
	 
	if (!blockAdditionOfSequences) {
		//NSLog(@"addSequenceAsLast: %i", lastSequence);
		[surfToSequence addObject:[[NSNumber alloc] initWithInt:lastSequence]];
	}
	else if (loggedOn==9 || loggedOn==99) {
		//NSLog(@"addSequenceAsLast: %i", lastSequence);
		[surfToSequence addObject:[[NSNumber alloc] initWithInt:lastSequence]];
	}
	else {
		//NSLog(@"addSequenceAsLast: BLOCKED");

	}

}

- (void) addSequenceAsLast: (int) firstInSequence to: (int) lastInSequence {
	if (!blockAdditionOfSequences) {
		//NSLog(@"addSequenceAsLast to:");
		for (int i=firstInSequence; i<=lastInSequence; i++) {
			[self addSequenceAsLast:i];
		}
	}
	else if (loggedOn==9 || loggedOn==99) {
		//NSLog(@"addSequenceAsLast: to: NON-FUNCTIONAL");
	}
	else {
		//NSLog(@"addSequenceAsLast: to: BLOCKED");
	}
}

- (void) pullNextSequence {
	//NSLog(@"pullNextSequence");
	if ([surfToSequence count]>0) {
		loggedOn = [[surfToSequence objectAtIndex:0] intValue];
		[surfToSequence removeObjectAtIndex:0];
	}
	else if ([surfToSequence count]==0) loggedOn = 8;
}

- (void) requestToSurfTo: (NSString *) URLAddress {
	//NSLog(@"requestToSurfTo:");
	if (!blockAdditionOfSequences) {
		//NSLog(@"requestToSurfTo: NOT BLOCKED");
		partialHTMLBody = @"";
		wholeHTMLBody = @"";
		recentURLAddress = [[NSString alloc] initWithString:URLAddress];
		[self surfTo:URLAddress];
	}

	else if (loggedOn==9 || loggedOn==99) {
		//NSLog(@"requestToSurfTo: 9 OR 99, URLADDRESS = %@",URLAddress);
		//partialHTMLBody = @"";
		//wholeHTMLBody = @"";
		recentURLAddress = [[NSString alloc] initWithString:URLAddress];
		[self surfTo:URLAddress];
	}
	
	else {
		//NSLog(@"requestToSurfTo: BLOCKED");
	}
}

#pragma mark Building Data & String Manipulation

- (void) getNameAndPasswordFromUserSettingObject {
	nameForLogin = [[NSString alloc] initWithString:[[_ViewController userSettingsObject] userName]];
	passwordForLogin = [[NSString alloc] initWithString:[[_ViewController userSettingsObject] password]];
}

- (NSString *) subStringStartingWith: (NSString *) startString 
			  cutFromFirstInstanceOf: (NSString *) markerString 
				   endCutWhenFinding: (NSString *) stopSring 
							inString: (NSString *) originalString {
	NSString *subStringText;
	
	if (originalString==nil) return @"AppsInfoUserAvatar subStringStartingWith: substring not found in original string";
	else if (originalString!=nil) {
		
		NSRange range = [originalString rangeOfString:startString];
		if (range.location==NSNotFound) return @"AppsInfoUserAvatar subStringStartingWith: substring not found in original string";
		else {
			subStringText = [originalString substringFromIndex:range.location];
			range = [subStringText rangeOfString:markerString];
			subStringText = [subStringText substringFromIndex:range.location+range.length];
			NSRange range2 = [subStringText rangeOfString:stopSring];
			NSRange range3 = NSMakeRange(0, range2.location);
			subStringText = [subStringText substringWithRange: range3];
			return subStringText;
		}
	}
}


- (void) extractSalesDataFrom: (NSString *) dailyData {
	NSString *headersHTML, *salesDataHTML, *tempString;
	NSMutableArray *headers, *salesData;
	NSMutableArray *salesData2DArray;
	applicationsNames = [[NSMutableArray alloc] initWithCapacity:50];

	NSRange range = [dailyData rangeOfString:@"\n"];
	headersHTML = [dailyData substringToIndex:range.location];
	range.location++;
	salesDataHTML = [dailyData substringFromIndex:range.location];
	headers = [headersHTML componentsSeparatedByString:@"\t"];
	
	salesData2DArray = [[NSMutableArray alloc] initWithCapacity:50];
	[salesData2DArray addObject:headers];
	
	while (!NSEqualRanges([salesDataHTML rangeOfString:@"\n"], NSMakeRange(NSNotFound, 0))) {
		
		NSString *singleSaleDataHTML;
		NSMutableArray *singleSaleData;
		
		range = [salesDataHTML rangeOfString:@"\n"];
		singleSaleDataHTML = [salesDataHTML substringToIndex:range.location];
		salesDataHTML = [salesDataHTML substringFromIndex:range.location+1];
		singleSaleData = [singleSaleDataHTML componentsSeparatedByString:@"\t"];
		
		[salesData2DArray addObject:singleSaleData];
	}
	
	salesObjects = [[NSMutableArray alloc] initWithCapacity:50];
	int countSalesData2DArray = [salesData2DArray count];
	int countFirstSalesDataArrayObject = [[salesData2DArray objectAtIndex:0] count];
	
	for (int j=1; j<countSalesData2DArray; j++) {
		
		SaleInfoObject *saleObject = [[SaleInfoObject alloc] init];
		for (int i=0; i<countFirstSalesDataArrayObject; i++) {
			
			
			if ([[[salesData2DArray objectAtIndex:0] objectAtIndex:i] isEqualToString:@"Title / Episode / Season"])	{
				tempString = [[salesData2DArray objectAtIndex:j] objectAtIndex:i];
				[saleObject setNameOfApp:[[NSString alloc] initWithString:tempString]];
				if ([applicationsNames indexOfObject:tempString]==NSNotFound) [applicationsNames addObject:[[NSString alloc] initWithString:tempString]];
			}
			else if ([[[salesData2DArray objectAtIndex:0] objectAtIndex:i] isEqualToString:@"Royalty Price"])	[saleObject setRoyaltyPrice:[[salesData2DArray objectAtIndex:j] objectAtIndex:i]];
			else if ([[[salesData2DArray objectAtIndex:0] objectAtIndex:i] isEqualToString:@"Units"])	[saleObject setUnits:[[salesData2DArray objectAtIndex:j] objectAtIndex:i]];
			else if ([[[salesData2DArray objectAtIndex:0] objectAtIndex:i] isEqualToString:@"Product Type Identifier"])	[saleObject setProductTypeIdentifier:[[salesData2DArray objectAtIndex:j] objectAtIndex:i]];
			else if ([[[salesData2DArray objectAtIndex:0] objectAtIndex:i] isEqualToString:@"Royalty Currency"])	[saleObject setRoyaltyCurrency:[[salesData2DArray objectAtIndex:j] objectAtIndex:i]];
			else if ([[[salesData2DArray objectAtIndex:0] objectAtIndex:i] isEqualToString:@"Country Code"])	[saleObject setCountryCode:[[salesData2DArray objectAtIndex:j] objectAtIndex:i]];

		}	
		[salesObjects addObject:saleObject];
	}
	//NSLog(@"applicationsNames = \n%@",applicationsNames);
}


- (void) extractAppPicURLFrom: (NSString *) applicationsData {
	//NSLog(@"%@", applicationsData);

	NSString *applicationsDataHTML, *applicationPicURL, *applicationStatus;
	NSMutableArray *tempAppNames = [[NSMutableArray alloc] initWithCapacity:50];
	NSMutableArray *tempAppPicURLs = [[NSMutableArray alloc] initWithCapacity:50];
	if (applicationsPicsURL==nil) applicationsPicsURL = [[NSMutableArray alloc] initWithCapacity:50];
	

	while (!NSEqualRanges([applicationsData rangeOfString:@"div class=\"recentTile\""], NSMakeRange(NSNotFound, 0)))	{
		
		NSRange range = [applicationsData rangeOfString:@"div class=\"recentTile\""];
		applicationsDataHTML = [applicationsData substringFromIndex:range.location];
		
		range = [applicationsDataHTML rangeOfString:@"<img"];
		applicationsDataHTML = [applicationsDataHTML substringFromIndex:range.location+range.length];
		range = [applicationsDataHTML rangeOfString:@"src=\""];
		applicationsDataHTML = [applicationsDataHTML substringFromIndex:range.location+range.length];
		range = [applicationsDataHTML rangeOfString:@"\""];
		applicationPicURL = [applicationsDataHTML substringToIndex:range.location];

		range = [applicationsDataHTML rangeOfString:@"div class=\"movieTitle app-search-recent\""];
		applicationsDataHTML = [applicationsDataHTML substringFromIndex:range.location];
		range = [applicationsDataHTML rangeOfString:@"<img"];
		applicationStatus = [applicationsDataHTML substringFromIndex:range.location+range.length];
		range = [applicationStatus rangeOfString:@"src=\""];
		applicationStatus = [applicationStatus substringFromIndex:range.location+range.length];
		range = [applicationStatus rangeOfString:@"\""];
		applicationStatus = [applicationStatus substringToIndex:range.location];
		
		range = [applicationsDataHTML rangeOfString:@"div class=\"app-name\""];
		
		applicationsData = [applicationsDataHTML substringFromIndex:range.location];
		
		applicationsDataHTML = [applicationsDataHTML substringFromIndex:range.location];
		range = [applicationsDataHTML rangeOfString:@">"];
		applicationsDataHTML = [applicationsDataHTML substringFromIndex:range.location+range.length];
		range = [applicationsDataHTML rangeOfString:@"<"];
		applicationsDataHTML = [applicationsDataHTML substringToIndex:range.location];
		
		//NSLog(@"applicationsDataHTML = %@", applicationsDataHTML);
		//NSLog(@"applicationPicURL = %@", applicationPicURL);
		

		if (!NSEqualRanges([applicationStatus rangeOfString:@"status-green"], NSMakeRange(NSNotFound, 0))) {
		
			[tempAppNames addObject:applicationsDataHTML];
			[tempAppPicURLs addObject:applicationPicURL];
		
		}

	}
	
	int picsToDownloadCount = [picsToDownload count];
	int tempAppNamesCount = [tempAppNames count];
	
	if (picsToDownloadCount!=0) {
		for (int i=0; i<picsToDownloadCount; i++) {
			int indexNum = [[picsToDownload objectAtIndex:i] intValue];
			NSString *appName = [applicationsNames objectAtIndex:indexNum];
			
			for (int j=0; j<tempAppNamesCount; j++) {
				if ([appName isEqualToString:[tempAppNames objectAtIndex:j]]) {
					//if (indexNum==0 && [applicationsPicsURL count]==0) [applicationsPicsURL addObject:[tempAppPicURLs objectAtIndex:j]];
					[applicationsPicsURL replaceObjectAtIndex:indexNum withObject:[tempAppPicURLs objectAtIndex:j]];
				}
			}
		}
	}
	//NSLog(@"extractAppPicURLFrom: applicationsPicsURL = %@",applicationsPicsURL);

	[[NSNotificationCenter defaultCenter] postNotificationName:@"obtained all app pics URLs" object:nil];


}


- (NSArray *) checkIfAppPicExistsInFolder {
	NSMutableArray *tempArray = [[NSMutableArray alloc] initWithCapacity:50];
	applicationsPics = [[NSMutableArray alloc] initWithCapacity:50];
	applicationsPicsURL = [[NSMutableArray alloc] initWithCapacity:50];
	
	for (int i=0; i<[applicationsNames count]; i++) {
		[applicationsPicsURL addObject:[[NSString alloc] initWithString:@"Missing"]];
		[applicationsPics addObject:[[NSString alloc] initWithString:@"Missing"]];
	}
	
	for (int i=0; i<[applicationsNames count]; i++) {
		
		NSFileManager *iconsfileManager = [NSFileManager defaultManager];
		NSString *iconFileName = [[NSString alloc] initWithFormat:@"%@.png",[applicationsNames objectAtIndex:i]];
		NSString *iconFilePath = [[NSString alloc] initWithFormat:@"%@/Documents/%@",NSHomeDirectory(),iconFileName];

		if ([iconsfileManager fileExistsAtPath: iconFilePath]) {
			[applicationsPicsURL replaceObjectAtIndex:i withObject:iconFilePath];
			[applicationsPics replaceObjectAtIndex:i withObject:iconFilePath];
		}
		else {
			[tempArray addObject:[[NSNumber alloc] initWithInt:i]];
		}
		
	}
	//NSLog(@"checkIfAppPicExistsInFolder: applicationsPicsURL = %@",applicationsPicsURL);
	//NSLog(@"checkIfAppPicExistsInFolder: applicationsPics = %@",applicationsPics);
	return tempArray;
}

- (void) getPictures {
	NSAutoreleasePool *releasePool = [[NSAutoreleasePool alloc] init];
	UIImage *img;
	NSURL *pictureURL;
	NSData *pictureData;
	NSString *iconFileName, *iconFilePath;
	//NSLog(@"getPictures: applicationsPicsURL = %@",applicationsPicsURL);
	
	for (int i=0; i<[applicationsPicsURL count]; i++) {
		if ([[applicationsPics objectAtIndex:i] isEqualToString:@"Missing"]) {
			NSFileManager *iconsfileManager = [NSFileManager defaultManager];
			iconFileName = [[NSString alloc] initWithFormat:@"%@.png",[applicationsNames objectAtIndex:i]];
			iconFilePath = [[NSString alloc] initWithFormat:@"%@/Documents/%@",NSHomeDirectory(),iconFileName];
			NSError *error;
			pictureURL = [NSURL URLWithString: [applicationsPicsURL objectAtIndex:i]];
			pictureData = [[NSData alloc] initWithContentsOfURL:pictureURL];
			if (pictureData!=nil) {
				[iconsfileManager createFileAtPath:iconFilePath contents:nil attributes:nil];
				[pictureData writeToFile:iconFilePath options:NSAtomicWrite error:&error];
			}
			//[applicationsPicsPaths addObject:iconFileName];
			img = [[UIImage alloc] initWithData:pictureData];
			//NSLog(@"getPictures: applicationsPics = %@", applicationsPics);
			if (img!=nil) {
				[applicationsPics replaceObjectAtIndex:i withObject:img];
			}
			else {
				[applicationsPics replaceObjectAtIndex:i withObject:[UIImage imageNamed:@"Missing_Icon.png"]];
			}

		}
		else {
			//NSLog(@"getPictures: applicationsPics = %@", applicationsPics);
			img = [UIImage imageWithContentsOfFile:[applicationsPicsURL objectAtIndex:i]];
			if (img!=nil) {
				[applicationsPics replaceObjectAtIndex:i withObject:img];
			}
			else {
				[applicationsPics replaceObjectAtIndex:i withObject:[UIImage imageNamed:@"Missing_Icon.png"]];
			}		
		}
	}

	[self performSelectorOnMainThread:@selector(reportDownloadedNotification:) withObject:@"App Icons Downloaded" waitUntilDone:NO];

	[releasePool drain];
}



- (NSArray *) summarizeAppSales {
	int countSalesObjects = [salesObjects count];
	int countApplicationsNames = [applicationsNames count];

	dataSummaryPerProduct = [[NSMutableArray alloc] initWithCapacity:50];
		 
	NSMutableArray *salesSummaryPerProduct = [[NSMutableArray alloc] initWithCapacity:50];
	NSMutableArray *upgradesSummaryPerProduct = [[NSMutableArray alloc] initWithCapacity:50];
	NSMutableArray *royaltiesSummaryPerProduct = [[NSMutableArray alloc] initWithCapacity:50];
	

	for (int j=0; j<countApplicationsNames; j++) {
		
		int salesSummary = 0;
		int upgradesSummary = 0;
		float royaltiesSummary = 0.0;
		
		NSString *appName = [applicationsNames objectAtIndex:j];
		for (int i=0; i<countSalesObjects; i++) {

			SaleInfoObject *saleObject = [salesObjects objectAtIndex:i];
			if ([[saleObject nameOfApp] isEqualToString:appName]) {

				if ([[saleObject productTypeIdentifier] intValue]==1) salesSummary = salesSummary + [[saleObject units] intValue];
				else if ([[saleObject productTypeIdentifier] intValue]==7) upgradesSummary = upgradesSummary + [[saleObject units] intValue];

				float conversionFloat = [[saleObject currencyConversionRate] floatValue];
				royaltiesSummary = royaltiesSummary + [[saleObject units] floatValue]*([[saleObject royaltyPrice] floatValue]/conversionFloat);
			}
		}

		[salesSummaryPerProduct addObject:[[NSNumber alloc] initWithInt:salesSummary]];
		[upgradesSummaryPerProduct addObject:[[NSNumber alloc] initWithInt:upgradesSummary]];
		[royaltiesSummaryPerProduct addObject:[[NSNumber alloc] initWithFloat:royaltiesSummary]];
	}

	[dataSummaryPerProduct addObject:applicationsNames];
	[dataSummaryPerProduct addObject:applicationsPics];
	[dataSummaryPerProduct addObject:salesSummaryPerProduct];
	[dataSummaryPerProduct addObject:upgradesSummaryPerProduct];
	[dataSummaryPerProduct addObject:royaltiesSummaryPerProduct];

	return dataSummaryPerProduct;
}

-(void) populateCountryToRegionDictionary: (NSDictionary *) countryAndRegionDictionary {

	regions = [[NSMutableArray alloc] initWithArray:[countryAndRegionDictionary allKeys]];
	[regions removeObjectAtIndex:[regions indexOfObject:@"Flags"]];
	sortedRegions = [[NSArray alloc] initWithArray:[regions sortedArrayUsingSelector:@selector(localizedCaseInsensitiveCompare:)]];
	int regionsCount = [regions count];
	for (int i=0; i<regionsCount; i++) {
		
		NSString *indexRegionName = [[NSString alloc] initWithString:[regions objectAtIndex:i]];
		NSArray *countriesOfIndexRegion = [countryAndRegionDictionary objectForKey:indexRegionName];
		int countriesOfIndexRegionCount = [countriesOfIndexRegion count];
		for (int j=0; j<countriesOfIndexRegionCount; j++) {
			[countryToRegion setObject:indexRegionName forKey:[countriesOfIndexRegion objectAtIndex:j]];
		}
		
	}
	//NSLog(@"countryToRegion = \n%@", countryToRegion);
	
}

- (void) populateRegionImagesArray: (NSDictionary *) countryAndRegionDictionary {
	regionFlagsFileNames = [[NSArray alloc] initWithArray:[countryAndRegionDictionary objectForKey:@"Flags"]];
}

- (NSArray *) regionFlagsFileNames {
	return regionFlagsFileNames;
}

- (UIImage *) imageOfAppNumber:(int)item{
	return [applicationsPics objectAtIndex:item];
}

- (NSString *) nameOfAppNumber:(int)item{
	return [applicationsNames objectAtIndex:item];
}

- (NSArray *) dailyDataPerProduct: (int)item {
	NSString *revenue = [[NSString alloc] initWithFormat:@"%.2f",[[[dataSummaryPerProduct objectAtIndex:4] objectAtIndex:item] floatValue]];
	NSString *sales = [[NSString alloc] initWithFormat:@"%i",[[[dataSummaryPerProduct objectAtIndex:2] objectAtIndex:item] intValue]];
	NSString *upgrades = [[NSString alloc] initWithFormat:@"%i",[[[dataSummaryPerProduct objectAtIndex:3] objectAtIndex:item] intValue]];
	return [[NSArray alloc] initWithObjects:[_ViewController updateDateFormat:lastDateOfSales], revenue, sales, upgrades, nil];
}

- (NSDictionary *) summarizeSalesPerRegionForAppNumber: (int) item keepOriginalRC: (BOOL) kORC {

	//NSLog(@"kORC = %i",kORC);
	int countSalesObjects = [salesObjects count];
	int countSortedRegions = [sortedRegions count];
	NSMutableArray *regionsWithSales = [[NSMutableArray alloc] initWithCapacity:7];
	NSMutableArray *tempRegions = [[NSMutableArray alloc] initWithArray:sortedRegions];
	NSMutableArray *tempFlags = [[NSMutableArray alloc] initWithArray:regionFlagsFileNames];
	
	[[NSNumber alloc] initWithInt:0];

	NSMutableArray *revenueByRegionPerProduct = [[NSMutableArray alloc] initWithCapacity:countSalesObjects];
	NSMutableArray *salesByRegionPerProduct = [[NSMutableArray alloc] initWithCapacity:countSalesObjects];
	NSMutableArray *upgradesByRegionPerProduct = [[NSMutableArray alloc] initWithCapacity:countSalesObjects];
	for (int i=0; i<countSortedRegions; i++) {
		[revenueByRegionPerProduct addObject:[[NSNumber alloc] initWithFloat:0.0]];
		[salesByRegionPerProduct addObject:[[NSNumber alloc] initWithInt:0]];
		[upgradesByRegionPerProduct addObject:[[NSNumber alloc] initWithInt:0]];
	}
	
	NSString *nameOfChosenApp = [[NSString alloc] initWithString:[applicationsNames objectAtIndex:item]];
	
	for (int i=0; i<countSalesObjects; i++){
	
		SaleInfoObject *saleObject = [salesObjects objectAtIndex:i];
		if ([[saleObject nameOfApp] isEqualToString:nameOfChosenApp]) {
			NSString *countryCodeOfSaleObject = [[NSString alloc] initWithString:[saleObject countryCode]];
			NSString *regionOfSaleObject = [[NSString alloc] initWithString:[countryToRegion objectForKey:countryCodeOfSaleObject]];
			if ([regionsWithSales indexOfObject:regionOfSaleObject]!=NSNotFound) {}
			else [regionsWithSales addObject:regionOfSaleObject];
			for (int j=0; j<countSortedRegions;j++) {
				if ([[sortedRegions objectAtIndex:j] isEqualToString:regionOfSaleObject]) {
					
					float tempRevenue = [[revenueByRegionPerProduct objectAtIndex:j] floatValue];
					int tempSales = [[salesByRegionPerProduct objectAtIndex:j] intValue];
					int tempUpgrades = [[upgradesByRegionPerProduct objectAtIndex:j] intValue];
					
					if ([[saleObject productTypeIdentifier] intValue]==1) tempSales = tempSales + [[saleObject units] intValue];
					else if ([[saleObject productTypeIdentifier] intValue]==7) tempUpgrades = tempUpgrades + [[saleObject units] intValue];
					
					if (kORC) {
						tempRevenue = tempRevenue + [[saleObject royaltyPrice] floatValue]*[[saleObject units] floatValue];
					}
					else if (!kORC) {
						float conversionFloat = [[saleObject currencyConversionRate] floatValue];
						tempRevenue = tempRevenue + ([[saleObject royaltyPrice] floatValue]/conversionFloat)*[[saleObject units] floatValue];
					}
		
					[revenueByRegionPerProduct replaceObjectAtIndex:j withObject:[[NSNumber alloc] initWithFloat:tempRevenue]];
					[salesByRegionPerProduct replaceObjectAtIndex:j withObject:[[NSNumber alloc] initWithInt:tempSales]];
					[upgradesByRegionPerProduct replaceObjectAtIndex:j withObject:[[NSNumber alloc] initWithInt:tempUpgrades]];
				}
					
			}
			
		}
	}
	int tempRegionsCount = [tempRegions count];
	for (int i = tempRegionsCount-1; i>=0; i--) {
		if ([regionsWithSales indexOfObject:[tempRegions objectAtIndex:i]]==NSNotFound) {
			[tempRegions removeObjectAtIndex:i];
			[tempFlags removeObjectAtIndex:i];
			[revenueByRegionPerProduct removeObjectAtIndex:i];
			[salesByRegionPerProduct removeObjectAtIndex:i];
			[upgradesByRegionPerProduct removeObjectAtIndex:i];
		}
	}
	
	NSMutableDictionary *salesSummaryByRegionPerProduct = [[NSMutableDictionary alloc] initWithCapacity:4];
	[salesSummaryByRegionPerProduct setObject:[[NSArray alloc] initWithArray:tempRegions] forKey:@"Region"];
	[salesSummaryByRegionPerProduct setObject:[[NSArray alloc] initWithArray:revenueByRegionPerProduct] forKey:@"Revenue"];
	[salesSummaryByRegionPerProduct setObject:[[NSArray alloc] initWithArray:salesByRegionPerProduct] forKey:@"Sales"];
	[salesSummaryByRegionPerProduct setObject:[[NSArray alloc] initWithArray:upgradesByRegionPerProduct] forKey:@"Upgrades"];
	[salesSummaryByRegionPerProduct setObject:[[NSArray alloc] initWithArray:tempFlags] forKey:@"Flags"];

	return [[NSDictionary alloc] initWithDictionary:salesSummaryByRegionPerProduct];
}



@end
