//
//  DailyReportByRegPerProdTVC.m
//  iSold_Apps
//
//  Created by Steve Sebban on 10/10/09.
//  Copyright 2009 KPL Production Services, Ltd.. All rights reserved.
//

#import "DailyReportByRegPerProdTVC.h"


@implementation DailyReportByRegPerProdTVC

@synthesize appIcon;
@synthesize appName;
@synthesize dateOfLastestSales;
@synthesize revenueLabel;
@synthesize salesLabel;
@synthesize upgradesLabel;

NSArray *dailyDataperRegionPerApp;
currencyObject *currencyHandler;
NSString *interfaceCurrency;
int keepORC;
/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/

- (void) populateDailyReportPerRegionWith: (NSDictionary *) dictionary 
							andDailyTotal: (NSArray *) dailyTotal 
							andFlagImages: (NSArray *) flags 
							   andAppInfo: (NSArray *) appInfo
						   keepOriginalRC: (int) kORC 
								iCurrency: (NSString *) currency {

	keepORC = kORC;
	interfaceCurrency = [[NSString alloc] initWithString:currency];

	NSMutableArray *tempArray = [[NSMutableArray alloc] initWithCapacity:[[dictionary objectForKey:@"Region"] count]];
	NSArray *regions = [[NSArray alloc] initWithArray:[dictionary objectForKey:@"Region"]];
	NSArray *revenue = [[NSArray alloc] initWithArray:[dictionary objectForKey:@"Revenue"]];
	NSArray *sales = [[NSArray alloc] initWithArray:[dictionary objectForKey:@"Sales"]];
	NSArray *upgrades = [[NSArray alloc] initWithArray:[dictionary objectForKey:@"Upgrades"]];
	
	
	[tempArray addObject:regions];
	[tempArray addObject:flags];
	[tempArray addObject:revenue];
	[tempArray addObject:sales];
	[tempArray addObject:upgrades];
	
	dailyDataperRegionPerApp = [[NSArray alloc] initWithArray:tempArray];
	
	CALayer *imageLayer = [CALayer layer];
	[imageLayer setContents:[[appInfo objectAtIndex:0] CGImage]]; 
	[appIcon setImage:[appInfo objectAtIndex:0]];
	[appName setText:[appInfo objectAtIndex:1]];
	[dateOfLastestSales setText:[dailyTotal objectAtIndex:0]];
	[revenueLabel setText:[[NSString alloc] initWithFormat:@"%@ %@",[currencyHandler getCurrencyFormatFor:currency],[dailyTotal objectAtIndex:1]]];
	[salesLabel setText:[dailyTotal objectAtIndex:2]];
	[upgradesLabel setText:[dailyTotal objectAtIndex:3]];
	
}


- (void)viewDidLoad {
    [super viewDidLoad];
	[[self tableView] setRowHeight:60.0f];
	[[self tableView] setAllowsSelection:NO];
	currencyHandler = [[currencyObject alloc] init];
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [[dailyDataperRegionPerApp objectAtIndex:0] count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"DailySalesByRegPerProdCell";
	NSString *nibName = @"DailyRegionalTable";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
		NSArray *topLevelObjects = [[NSBundle mainBundle] loadNibNamed:nibName owner:self options:nil];
		
		for (id currentObject in topLevelObjects){
			if ([currentObject isKindOfClass:[UITableViewCell class]]){
				cell =  (DailyReportByRegPerProdTCell *) currentObject;
				
				break;
			}
		}
    }
    
    // Set up the cell...
	UIImage *img = [UIImage imageNamed:[[dailyDataperRegionPerApp objectAtIndex:1] objectAtIndex:indexPath.row]];
	CALayer *imageLayer = [CALayer layer];
	[imageLayer setContents:[img CGImage]]; 
	[[cell regionIcon] setImage:img];
	
	[[cell revenue] setText:[[NSString alloc] initWithFormat:@"%@ %.2f",keepORC?[currencyHandler getCurrencyFormatForRegion:[[dailyDataperRegionPerApp objectAtIndex:0] objectAtIndex:indexPath.row]]:[currencyHandler getCurrencyFormatFor:interfaceCurrency],[[[dailyDataperRegionPerApp objectAtIndex:2] objectAtIndex:indexPath.row] floatValue]]];
	[[cell sales] setText:[[NSString alloc] initWithFormat:@"%i",[[[dailyDataperRegionPerApp objectAtIndex:3] objectAtIndex:indexPath.row] intValue]]];
	[[cell upgrades] setText:[[NSString alloc] initWithFormat:@"%i",[[[dailyDataperRegionPerApp objectAtIndex:4] objectAtIndex:indexPath.row] intValue]]];
    return cell;
}

/*
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
}
*/

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


- (void)dealloc {
    [super dealloc];
}


@end

