//
//  DailySalesTableView.m
//  iSold_Apps
//
//  Created by Steve Sebban on 21/09/09.
//  Copyright 2009 KPL Production Services, Ltd.. All rights reserved.
//

#import "DailySalesTableView.h"


@implementation DailySalesTableView

BOOL dailyDataReceived;
NSArray *dailySalesDataPerAppArray;
currencyObject *currencyHandler;
 /*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/


- (void)viewDidLoad {
    [super viewDidLoad];
	[[self tableView] setRowHeight:87.0f];
	dailyDataReceived = NO;
	currencyHandler = [[currencyObject alloc] init];
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}


/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
if (!dailyDataReceived) return 0;
else if (dailyDataReceived) return [[dailySalesDataPerAppArray objectAtIndex:1] count];
	return 0;
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"DailySaleCell";
	NSString *nibName = @"DailySalePerAppCell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
		NSArray *topLevelObjects = [[NSBundle mainBundle] loadNibNamed:nibName owner:self options:nil];
		
		for (id currentObject in topLevelObjects){
			if ([currentObject isKindOfClass:[UITableViewCell class]]){
				cell =  (DailySaleTableCell *) currentObject;

				break;
			}
		}
    }
    
    // Set up the cell...
	if (dailyDataReceived) {

		UIImage *img = [[dailySalesDataPerAppArray objectAtIndex:1] objectAtIndex:indexPath.row];
		CALayer *imageLayer = [CALayer layer];
		[imageLayer setContents:[img CGImage]];
		[cell setSelectedTraits];
		[[cell appIcon] setImage:img];
		[[cell appName] setText:[[dailySalesDataPerAppArray objectAtIndex:0] objectAtIndex:indexPath.row]];
		[[cell revenue] setText:[[NSString alloc] initWithFormat:@"%@ %.2f",[currencyHandler getCurrencyFormatFor:[[parentViewConroller userSettingsObject] interfaceCurrency]] ,[[[dailySalesDataPerAppArray objectAtIndex:4] objectAtIndex:indexPath.row] floatValue]]];
		[[cell sales] setText:[[NSString alloc] initWithFormat:@"%i",[[[dailySalesDataPerAppArray objectAtIndex:2] objectAtIndex:indexPath.row] intValue]]];
		[[cell upgrades] setText:[[NSString alloc] initWithFormat:@"%i",[[[dailySalesDataPerAppArray objectAtIndex:3] objectAtIndex:indexPath.row] intValue]]];
	}
	
    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
	[parentViewConroller switchToDailyRegionalViewWithIndex:indexPath.row];
	[[self tableView] deselectRowAtIndexPath:indexPath animated:YES];
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, 
 insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

- (void) populateDailySalesTableWith: (NSArray *) dailySalesDataArray {

	dailySalesDataPerAppArray = [[NSArray alloc] initWithArray:dailySalesDataArray];
	dailyDataReceived = YES;
	[[self tableView] reloadData];
}

- (void)dealloc {
    [super dealloc];
}


@end

