//
//  FirstViewController.h
//  iSold_Apps
//
//  Created by Steve Sebban on 17/09/09.
//  Copyright KPL Production Services, Ltd. 2009. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import "AppsInfoUserAvatar.h"
#import "DailySalesTableView.h"
#import "DailyReportByRegPerProdTVC.h"
#import "SettingsObject.h"
#import "currencyObject.h"

@interface FirstViewController : UIViewController <UIAlertViewDelegate, UINavigationControllerDelegate>{

	IBOutlet UITabBarController *tabBarController;
	IBOutlet UINavigationController *navController;
	IBOutlet UIViewController *latestReportViewController;
	IBOutlet UIViewController *dailyByRegionReportViewController;
	IBOutlet UILabel *dateOfLastestSales;
	IBOutlet UILabel *revenueLabel;
	IBOutlet UILabel *salesLabel;
	IBOutlet UILabel *upgradesLabel;
	IBOutlet UILabel *dateAndTimeLastChecked;
	IBOutlet UITableViewController *dailySalesTableController;
	IBOutlet UIActivityIndicatorView *indicator;
	IBOutlet UILabel *statusLabel;
	IBOutlet UIView *statusToolbarView;
	IBOutlet UIBarButtonItem *cancelButton;
	SettingsObject *userSettingsObject;
	NSDictionary *countryNamesAndRegions;
	IBOutlet DailyReportByRegPerProdTVC *tVCPerDayByRegPerProd;

}

@property (nonatomic,assign) IBOutlet UILabel *dateOfLastestSales;
@property (nonatomic,assign) IBOutlet UILabel *revenueLabel;
@property (nonatomic,assign) IBOutlet UILabel *salesLabel;
@property (nonatomic,assign) IBOutlet UILabel *upgradesLabel;
@property (nonatomic,assign) IBOutlet UILabel *dateAndTimeLastChecked;
@property (nonatomic,assign) IBOutlet UITableViewController *dailySalesTableController;
@property (nonatomic,assign) IBOutlet UIActivityIndicatorView *indicator;
@property (nonatomic,assign) IBOutlet UILabel *statusLabel;
@property (nonatomic,assign) IBOutlet UIView *statusToolbarView;
@property (nonatomic,assign) IBOutlet UIBarButtonItem *cancelButton;
@property (nonatomic,assign) NSDictionary *countryNamesAndRegions;

- (BOOL) checkNetworkAvailibility;
- (void) populateView: (SettingsObject *) settings;
- (void) updateView;
- (void) populateDailySalesViewWith: (NSArray *) dailySalesData;
- (void) switchToDailyRegionalViewWithIndex: (int) rowNumber andData: (NSArray *) dailySalesDataPerAppArray;
- (void) cancelAvatarConnection;
- (IBAction) cancelButtonPressed: (id) sender;
- (IBAction) refreshButtonPressed: (id) sender;
- (void) clearNotificationTextAndBringRefreshBarToFront;
- (void) bringNotificationTextToFront;
- (void)didPresentAlertView:(UIAlertView *)alertView;
- (void)alertViewCancel:(UIAlertView *)alertView;
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex;
- (void) updateViewWith:(NSString *) data;
- (void) addNotificationRequestFrom: (id) Requestor toOperate: (SEL) method WithMessage: (NSString *) notificationString;
- (void) removeNotificationRequestFrom: (id) Requestor WithMessage: (NSString *) notificationString;
- (BOOL) doesMessageExistInDispatchList: (NSString *) message;
- (void) validateLoginDetailsWithName: (NSString *) tempName andPassword: (NSString *) tempCodeword;
- (BOOL) doesUserAvatarExist;
- (void) setActivityWindowContentTo: (int) content;
- (void) clearNotificationDispatchList;
- (void) clearNotificationDispatchListExceptFor: (NSArray *) notificationStringArray;
- (void) displayNotificationCenterDispatchList;
- (void) displayNotificationCenterDispatchListObservers;
- (void) updateAvatarUsernameAndPasswordWith: (SettingsObject *) settings;
@end
