//
//  FirstViewController.m
//  iSold_Apps
//
//  Created by Steve Sebban on 17/09/09.
//  Copyright KPL Production Services, Ltd. 2009. All rights reserved.
//

#import "FirstViewController.h"


@implementation FirstViewController

@synthesize dateOfLastestSales;
@synthesize revenueLabel;
@synthesize salesLabel;
@synthesize upgradesLabel;
@synthesize dateAndTimeLastChecked;
@synthesize dailySalesTableController;
@synthesize indicator;
@synthesize statusLabel;
@synthesize statusToolbarView;
@synthesize cancelButton;
@synthesize countryNamesAndRegions;

AppsInfoUserAvatar *userAvatar;
SettingsObject *userSettingsObject;
NSTimer* myTimer;
currencyObject *currencyHandler;
/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


- (void)viewDidLoad {
    [super viewDidLoad];
	[[self view] addSubview:[navController view]];
	[[self view] addSubview:statusToolbarView];
	[navController setNavigationBarHidden:NO];
	[navController setDelegate:self];
	[statusToolbarView setHidden:NO];
	[[navController view] setTag:2];
	[statusToolbarView setTag:3];
	[[self view] bringSubviewToFront:[[self view] viewWithTag:2]];
	currencyHandler = [[currencyObject alloc] init];
}


#pragma mark Initiation of Objects

- (void) awakeFromNib {
	if ([indicator isAnimating]) [indicator stopAnimating];
	[indicator setHidesWhenStopped:YES];
}

#pragma mark getter Functions

- (SettingsObject *) userSettingsObject {
	return userSettingsObject;
}

- (BOOL) isConnectionRunning {
	return [userAvatar isCurrentConnectionRunning];
}

- (void) addNotificationRequestFrom: (id) Requestor toOperate: (SEL) method WithMessage: (NSString *) notificationString {
	[tabBarController addNotificationRequestFrom: Requestor toOperate: method WithMessage:notificationString];
}

- (void) removeNotificationRequestFrom: (id) Requestor WithMessage: (NSString *) notificationString {
	[tabBarController removeNotificationRequestFrom: Requestor WithMessage: notificationString];
}

- (BOOL) doesMessageExistInDispatchList: (NSString *) message {
	if ([[tabBarController notificationCenterDispatchList] indexOfObject:message]==NSNotFound) return NO;
	else return YES;
}

- (void) clearNotificationDispatchList {
	
	NSArray *tempDispatchList = [[NSArray alloc] initWithArray:[tabBarController notificationCenterDispatchList]];
	NSArray *tempObjectList = [[NSArray alloc] initWithArray:[tabBarController notificationCenterDispatchListObservers]];
	int counter = [tempDispatchList count];
	for (int i=0; i<counter; i++) {
		[tabBarController removeNotificationRequestFrom:[tempObjectList objectAtIndex:i] WithMessage:[tempDispatchList objectAtIndex:i]];
	}
	//NSLog(@"clearNotificationDispatchList: notificationCenterDispatchList=%@", [tabBarController notificationCenterDispatchList]);

}	

- (void) clearNotificationDispatchListExceptFor: (NSArray *) notificationStringArray {
	NSArray *tempDispatchList = [[NSArray alloc] initWithArray:[tabBarController notificationCenterDispatchList]];
	NSArray *tempObjectList = [[NSArray alloc] initWithArray:[tabBarController notificationCenterDispatchListObservers]];
	int counter = [tempDispatchList count];
	int arrayCount = [notificationStringArray count];
	BOOL exists;
	for (int i=0; i<counter; i++) {
		exists = NO;
		for (int j=0; j<arrayCount; j++) {
			if ([[tempDispatchList objectAtIndex:i] isEqualToString:[notificationStringArray objectAtIndex:j]]) exists = YES;
		}
		if (!exists) [tabBarController removeNotificationRequestFrom:[tempObjectList objectAtIndex:i] WithMessage:[tempDispatchList objectAtIndex:i]];
	}
	//NSLog(@"clearNotificationDispatchList: notificationCenterDispatchList=%@", [tabBarController notificationCenterDispatchList]);
	
}


- (void) displayNotificationCenterDispatchList {
	return [tabBarController notificationCenterDispatchList];
	
}

- (void) displayNotificationCenterDispatchListObservers {
	return [tabBarController notificationCenterDispatchListObservers];
	
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

#pragma mark Interface Updating

- (BOOL) checkNetworkAvailibility {
	return [tabBarController checkNetworkAvailibility];	
}


- (void) populateView: (SettingsObject *) settings {
	[statusLabel setText:@""];
	userSettingsObject = settings;
	//NSLog(@"userAvatar!=NULL = %@", (userAvatar!=NULL)?@"Yes":@"NO");
	//NSLog(@"userAvatar = %@", userAvatar);
	if (userAvatar!=NULL) {
		[userAvatar processLogin];
		//NSLog(@"populateView: userSettingsObject = %@",userSettingsObject);
	}
	else {
		userAvatar = [[AppsInfoUserAvatar alloc] initConnectionWithAppsInfo:self andValidate:NO];
		[userAvatar processLoadPreviousReportDetails];
	}
	//[[self view] bringSubviewToFront:[[self view] viewWithTag:2]];
	//[indicator startAnimating];

}

- (void) setUserSettingsObject: (SettingsObject *) settings {
	userSettingsObject = settings;
	//if (userAvatar!=NULL) [userAvatar updatePreferredCurrency];
	//NSLog(@"setUserSettingsObject:");

}

- (void) updateView {
	[statusLabel setText:@""];
	//NSLog(@"updateView: userSettingsObject = %@", [self userSettingsObject]);
	if (userAvatar!=NULL) {
		userAvatar = [[AppsInfoUserAvatar alloc] initConnectionWithAppsInfo:self andValidate:NO];
		[userAvatar setViewUpdated:YES];
		[userAvatar processLoadPreviousReportDetails];
	}
	else {
		//NSLog(@"updateView: userAvatar==NULL");
	}

}

- (void) populateDailySalesViewWith: (NSArray *) dailySalesData {
	int countApplications = [[dailySalesData objectAtIndex:0] count];
	
	float totalRevenues = 0.0;
	int totalSales = 0;
	int totalUpgrades = 0;
	
	for (int i=0; i<countApplications; i++) {
		totalSales = totalSales +[[[dailySalesData objectAtIndex:2] objectAtIndex:i] intValue];
		totalUpgrades = totalUpgrades +[[[dailySalesData objectAtIndex:3] objectAtIndex:i] intValue];
		totalRevenues = totalRevenues +[[[dailySalesData objectAtIndex:4] objectAtIndex:i] floatValue];
	}

	[dateOfLastestSales setText:[self updateDateFormat:[userAvatar lastDateOfSales]]];
	[revenueLabel setText:[[NSString alloc] initWithFormat:@"%@ %.2f",[currencyHandler getCurrencyFormatFor:[userSettingsObject interfaceCurrency]],totalRevenues]];
	[salesLabel setText:[[NSString alloc] initWithFormat:@"%i",totalSales]];
	[upgradesLabel setText:[[NSString alloc] initWithFormat:@"%i",totalUpgrades]];
	[dailySalesTableController populateDailySalesTableWith:dailySalesData];
	//[indicator stopAnimating];
	//[[self view] bringSubviewToFront:[[self view] viewWithTag:2]];

}

- (NSString *) updateDateFormat: (NSString *) date {
	if ([userAvatar lastDateOfSales]!=nil) {
		if (userSettingsObject.dateFormat==1) {
			NSString *USDate = [[NSString alloc] initWithString:date];
			NSArray *dateComponents = [USDate componentsSeparatedByString:@"/"];
			if ([dateComponents count]==3) {
				NSString *EUDate = [[NSString alloc] initWithFormat:@"%@/%@/%@", [dateComponents objectAtIndex:1], [dateComponents objectAtIndex:0], [dateComponents objectAtIndex:2]];
				return EUDate;
			}
		}
		else if (userSettingsObject.dateFormat==0) {
			return date;
		}
	}
	
}

- (NSString *) updateTimeFormat: (NSString *) time {
	if ([userAvatar lastDateOfSales]!=nil) {
		if (userSettingsObject.dateFormat==1) {
			return time;
		}
		else if (userSettingsObject.dateFormat==0) {
			NSString *EUTime = [[NSString alloc] initWithString:time];
			NSArray *timeComponents = [EUTime componentsSeparatedByString:@":"];
			if ([timeComponents count]==2) {
				int hour = [[timeComponents objectAtIndex:0] intValue];
				NSString *AMPMComponent;
				//NSLog(@"hour = %i", hour);
				if (hour>=13) {
					hour = hour - 12;
					AMPMComponent = [[NSString alloc] initWithString:@"PM"];
				}
				else if (hour<13) {
					AMPMComponent = [[NSString alloc] initWithString:@"AM"];
				}
				NSString *USTime = [[NSString alloc] initWithFormat:@"%i:%@ %@", hour, [timeComponents objectAtIndex:1], AMPMComponent];
				return USTime;
			}
		}
	}
	
}

- (void) validationResult: (BOOL *) accessConfirmed {
	[indicator stopAnimating];
	[[self view] bringSubviewToFront:[[self view] viewWithTag:2]];
	[tabBarController validationResult:accessConfirmed];
}

- (void) unexpectedPage {
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Important" message:@"Unrecognized information was encountered after logging in to itunesconnect.\n Please review and attend before proceeding." delegate:self cancelButtonTitle:@"View webpage in Safari" otherButtonTitles:nil];
	[alert show];
	[alert release];
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
	if ([[alertView title] isEqualToString:@"Important"]) {
		//[[UIApplication sharedApplication] openURL:[NSURL URLWithString:[[NSString alloc] initWithFormat:@"https://itunesconnect.apple.com?theAccountName=%@&theAccountPW=%@",[userSettingsObject userName],[userSettingsObject password]]]];
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void) validateLoginDetailsWithName: (NSString *) tempName andPassword: (NSString *) tempCodeword {
	[statusLabel setText:@"Checking Login Details"];
	userSettingsObject = [[SettingsObject alloc] initWithUserName:tempName 
														 password:tempCodeword 
										validatedNamesAndPassword:NO 
												interfaceCurrency:[[self userSettingsObject] interfaceCurrency]
														  dFormat:0 
													checkAtLaunch:NO 
									   keepOriginalRegionCurrency:YES];
	if (userAvatar!=NULL) {
		[userAvatar initConnectionWithAppsInfo:self andValidate:YES];
		[userAvatar processLogin];
	}
	else {
		userAvatar = [[AppsInfoUserAvatar alloc] initConnectionWithAppsInfo:self andValidate:YES];
		[userAvatar processLogin];
	}
	[[self view] bringSubviewToFront:[[self view] viewWithTag:3]];
	[indicator startAnimating];
}

- (BOOL) doesUserAvatarExist {
	if (userAvatar!=NULL) {
		//NSLog(@"doesUserAvatarExist YES");
		return YES;
	}
	else {
		//NSLog(@"doesUserAvatarExist NO");
		return NO;
	}
}

- (void) setActivityWindowContentTo: (int) content {
	[tabBarController setActivityWindowContentTo:content];
}


#pragma mark Interaction Responses

- (IBAction) cancelButtonPressed: (id) sender {	
	//NSLog(@"%@",[tabBarController notificationCenterDispatchList]);
	if (![self doesMessageExistInDispatchList:@"Connection Completed Download"]) {
		[self cancelAvatarConnection];
		[self clearNotificationTextAndBringRefreshBarToFront];
		[tabBarController setActivityWindowContentTo:0];
	}
	else if ([self doesMessageExistInDispatchList:@"Connection Completed Download"]) [[self view] bringSubviewToFront:[[self view] viewWithTag:2]];
}

- (IBAction) refreshButtonPressed: (id) sender {
	//NSLog(@"%@",[tabBarController notificationCenterDispatchList]);
	//[userAvatar setIsRefreshSessionRunning:YES];
	if ([self checkNetworkAvailibility]) {
		SettingsObject *tempSettings = [tabBarController initialSettingsFileCheck];
		if (![[tempSettings userName] isEqualToString:@""] && ![[tempSettings password] isEqualToString:@""]) {
			[indicator startAnimating];
			[statusLabel setText:@"Please Wait"];
			if ([self doesMessageExistInDispatchList:@"Logout Completed"]) [tabBarController removeAllNotificationObserversWithMessage:@"Logout Completed"];
			[self addNotificationRequestFrom:self toOperate:@selector(didCurrentAvatarLogOut) WithMessage:@"Logout Completed"];
			//NSLog(@"notificationCenterDispatchList = %@",[tabBarController notificationCenterDispatchList]);
			[userAvatar cancelCurrentConnection];
			[[self view] bringSubviewToFront:[[self view] viewWithTag:3]];
		}
		else {
			UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Missing Details" message:@"Please first enter your \nusername & password" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
			[alert show];
			[alert release];
			//NSLog(@"No Username or Password");
		}

	}
	else {}
}

- (void) didCurrentAvatarLogOut {
	//NSLog(@"didCurrentAvatarLogOut");
		[tabBarController removeNotificationRequestFrom:self WithMessage:@"Logout Completed"];
		//NSLog(@"[tabBarController userSettings] = %@",[tabBarController userSettings]);
		userSettingsObject = [tabBarController userSettings];
		//[userAvatar setIsRefreshSessionRunning:NO];
		[self populateView:userSettingsObject];
}

- (void) cancelAvatarConnection {
	if (userAvatar!=NULL) [userAvatar cancelCurrentConnection];
	else [[NSNotificationCenter defaultCenter] postNotificationName:@"Logout Completed" object:nil]; 

	[indicator stopAnimating];
}

- (void) clearNotificationTextAndBringRefreshBarToFront {
	[indicator stopAnimating];
	[statusLabel setText:@""];
	[[self view] bringSubviewToFront:[[self view] viewWithTag:2]];
}

- (void) bringNotificationTextToFront {
	[indicator startAnimating];
	[[self view] bringSubviewToFront:[[self view] viewWithTag:3]];
}


- (void) switchToDailyRegionalViewWithIndex: (int) rowNumber {
	NSMutableDictionary *tempDictionary = [[NSMutableDictionary alloc] initWithDictionary:[userAvatar summarizeSalesPerRegionForAppNumber:rowNumber keepOriginalRC:userSettingsObject.keepOriginalRegionCurrency]];
	NSArray *tempFlagsFileNames = [[NSArray alloc] initWithArray:[tempDictionary objectForKey:@"Flags"]];
	[tempDictionary removeObjectForKey:@"Flags"];
	NSArray *dailyTotal = [[NSArray alloc] initWithArray:[userAvatar dailyDataPerProduct:rowNumber]];
	NSArray *appInfo = [[NSArray alloc] initWithObjects:[userAvatar imageOfAppNumber:rowNumber], [userAvatar nameOfAppNumber:rowNumber],nil];
	[tVCPerDayByRegPerProd populateDailyReportPerRegionWith:(NSDictionary *)tempDictionary 
											  andDailyTotal:dailyTotal 
											  andFlagImages:tempFlagsFileNames 
												 andAppInfo:appInfo keepOriginalRC:userSettingsObject.keepOriginalRegionCurrency 
												  iCurrency:userSettingsObject.interfaceCurrency];
	[[tVCPerDayByRegPerProd tableView] reloadData];

	[[self view] bringSubviewToFront:[[self view] viewWithTag:2]];
	[dailyByRegionReportViewController setTitle:[userAvatar nameOfAppNumber:rowNumber]];
	[navController pushViewController:dailyByRegionReportViewController animated:YES];
}

- (void) updateViewWith:(NSString *) data{
	if ([data isEqualToString:@"Date"]) {
		//NSLog(@"[userAvatar lastDateOfSales] = %@", [userAvatar lastDateOfSales]);
		if ([userAvatar lastDateOfSales]!=NULL) {
			[dateOfLastestSales setText:[self updateDateFormat:[userAvatar lastDateOfSales]]];
			[self updateLastCheckedOn:[userAvatar dateAndTimeLastChecked]];
		}
		else {
			[dateOfLastestSales setText:@"No Previous Record"];
			[dateAndTimeLastChecked setText:@"Never Checked"];
		}			
	}
}

- (void)navigationController:(UINavigationController *)navigationController willShowViewController:(UIViewController *)viewController animated:(BOOL)animated {
	if ([indicator isAnimating] && [[navigationController viewControllers] indexOfObject:viewController]==0) {
		[[self view] bringSubviewToFront:[[self view] viewWithTag:3]]; 
	}
}

- (void) updateLastCheckedOn: (NSDate *) dateAndTime{
	NSString *dateAndTimeString = [[NSString alloc] initWithFormat:@"%@",dateAndTime];
	NSArray *dateAndTimeComponents = [dateAndTimeString componentsSeparatedByString:@" "];
	NSArray *dateComponents = [[dateAndTimeComponents objectAtIndex:0] componentsSeparatedByString:@"-"];
	NSString *dateInUSFormat = [[NSString alloc] initWithFormat:@"%@/%@/%@",[dateComponents objectAtIndex:1], [dateComponents objectAtIndex:2], [dateComponents objectAtIndex:0]];
	[dateAndTimeLastChecked setText:[[NSString alloc] initWithFormat:@"%@ %@",[self updateDateFormat:dateInUSFormat], [self updateTimeFormat:[[dateAndTimeComponents objectAtIndex:1] substringToIndex:5]]]];
}

- (void) updateAvatarUsernameAndPasswordWith: (SettingsObject *) settings {
	[userSettingsObject setUserName:[settings userName]];
	[userSettingsObject setPassword:[settings password]];
	if (userAvatar!=NULL) {
		[userAvatar getNameAndPasswordFromUserSettingObject];
	}
}

- (void)dealloc {
    [super dealloc];
}

@end
