//
//  MainTabBarController.h
//  iSold_Apps
//
//  Created by Steve Sebban on 26/09/09.
//  Copyright 2009 KPL Production Services, Ltd.. All rights reserved.
//

#import <Foundation/NSNotification.h>
#import <UIKit/UIKit.h>
#import "SettingsObject.h"
#import "ReachabilityAppDelegate.h"

@interface MainTabBarController : UITabBarController <UITabBarControllerDelegate> {

	IBOutlet UITabBar *mainTabBar;
	IBOutlet UIViewController *firstViewController;
	IBOutlet UIViewController *secondViewController;
	NSMutableArray *notificationCenterDispatchList;
	NSMutableArray *notificationCenterDispatchListObservers;
	
}

@property (nonatomic, assign) NSMutableArray *notificationCenterDispatchList;
@property (nonatomic, assign) NSMutableArray *notificationCenterDispatchListObservers;

- (BOOL) checkNetworkAvailibility;
- (void) updateFirstView;
- (SettingsObject *) initialSettingsFileCheck;
- (void) setFirstViewUserSettingsObject: (SettingsObject *) settings;
- (void) isTabBarEnabled: (BOOL) enabled;
- (void) updateDataInView: (NSString *) dataToBeUpdated;
- (BOOL) doesUserAvatarExistInFirstViewController;
- (void) addNotificationRequestFrom: (id) Requestor toOperate: (SEL) method WithMessage: (NSString *) notificationString;
- (void) removeNotificationRequestFrom: (id) Requestor WithMessage: (NSString *) notificationString;
- (void) removeAllNotificationObserversWithMessage: (NSString *) notificationString;
- (void) cancelButtonPressed: (id) sender;
- (void) validateLoginDetailsWithName: (NSString *) tempName andPassword: (NSString *) tempCodeword;
- (void) validationResult: (BOOL *) accessConfirmed;
- (void) setActivityWindowContentTo: (int) content;
- (void) updateAvatarUsernameAndPasswordWith: (SettingsObject *) settings;
@end
