//
//  MainTabBarController.m
//  iSold_Apps
//
//  Created by Steve Sebban on 26/09/09.
//  Copyright 2009 KPL Production Services, Ltd.. All rights reserved.
//

#import "MainTabBarController.h"


@implementation MainTabBarController

@synthesize notificationCenterDispatchList;
@synthesize notificationCenterDispatchListObservers;

SettingsObject *userSettings;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

/*
- (void)tabBarController:(UITabBarController *)tabBarController didSelectViewController:(UIViewController *)viewController {
}
 */

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	notificationCenterDispatchList = [[NSMutableArray alloc] initWithCapacity:20];
	notificationCenterDispatchListObservers = [[NSMutableArray alloc] initWithCapacity:20];
	[self setDelegate:self];
	[self setSelectedIndex:0];
	int selectedIndexBackup = [self selectedIndex];
	[self setSelectedIndex:1];
	[self setSelectedIndex:selectedIndexBackup];

	NSString *plistPath = [[NSString alloc] initWithFormat:@"%@/Currencies.plist",[[NSBundle mainBundle] bundlePath]];
	NSDictionary *dictionaryOfCurrencies = [[NSDictionary alloc] initWithContentsOfFile:plistPath];
	[secondViewController setCountriesAndCurrencies:dictionaryOfCurrencies];
	[secondViewController createCurrencyArray:[dictionaryOfCurrencies objectForKey:@"currencyNames"]];

	plistPath = [[NSString alloc] initWithFormat:@"%@/Regions_List.plist",[[NSBundle mainBundle] bundlePath]];
	NSDictionary *dictionaryOfCountries = [[NSDictionary alloc] initWithContentsOfFile:plistPath];
	
	[firstViewController setCountryNamesAndRegions:dictionaryOfCountries];
	

	userSettings = [secondViewController initialSettingsFileCheck];

	if (userSettings==nil) {
		userSettings = [[SettingsObject alloc] initWithUserName:@"" 
													   password:@""
									  validatedNamesAndPassword:NO
											  interfaceCurrency:@"default" 
														dFormat:0 
												  checkAtLaunch:NO 
									 keepOriginalRegionCurrency:YES];
		[secondViewController setUserSettingsObject:userSettings];
		[secondViewController saveUserSettings];
	}
	else {
		[secondViewController setUserSettingsObject:userSettings];
	}
	[secondViewController setSettingsInView];
	if ([[userSettings userName] isEqualToString:@""] || [[userSettings password] isEqualToString:@""]) [self setSelectedIndex:1];
	else {
		[firstViewController populateView:userSettings];
	}

	
}

- (BOOL) checkNetworkAvailibility {
	BOOL isNetworkAvailable = [[ReachabilityAppDelegate alloc] init];
	if (!isNetworkAvailable) {
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error Loading" message:@"No Network Connection" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];
		return isNetworkAvailable;
	}
	else if (isNetworkAvailable) return isNetworkAvailable;
}

- (void) updateFirstView {
	[firstViewController updateView];
}

- (void) setFirstViewUserSettingsObject: (SettingsObject *) settings {
	userSettings = settings;
	[firstViewController setUserSettingsObject:settings];
}

- (SettingsObject *) initialSettingsFileCheck {
	return [secondViewController initialSettingsFileCheck];
}
/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/
- (BOOL) isConnectionRunningForFirstView {
	return [firstViewController isConnectionRunning];
}

- (void) cancelLoginAvatarIfRunning {
	//NSLog(@"cancelLoginAvatarIfRunning");
	[firstViewController cancelAvatarConnection];
}

- (void) cancelButtonPressed: (id) sender {
	[firstViewController cancelButtonPressed:sender];
}

- (void) validateLoginDetailsWithName: (NSString *) tempName andPassword: (NSString *) tempCodeword {
	[firstViewController validateLoginDetailsWithName: tempName andPassword: tempCodeword];
}

- (void) validationResult: (BOOL *) accessConfirmed {
	[secondViewController validationResult:accessConfirmed];
}

- (SettingsObject *) userSettings {
	return userSettings;
}

- (void) isTabBarEnabled: (BOOL) enabled {
	[mainTabBar setUserInteractionEnabled:enabled];
}

- (void) updateDataInView: (NSString *) dataToBeUpdated {
	[firstViewController updateViewWith:dataToBeUpdated];
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (BOOL) doesUserAvatarExistInFirstViewController {
	return [firstViewController doesUserAvatarExist];
}

- (void) addNotificationRequestFrom: (id) Requestor toOperate: (SEL) method WithMessage: (NSString *) notificationString {
	[[NSNotificationCenter defaultCenter] addObserver:Requestor selector:method name:notificationString object:nil];
	[notificationCenterDispatchList addObject:notificationString];
	[notificationCenterDispatchListObservers addObject:Requestor];
	//NSLog(@"#1 Object %@ requested to add Notification \"%@",Requestor, notificationString);
}

- (void) removeNotificationRequestFrom: (id) Requestor WithMessage: (NSString *) notificationString {
	[[NSNotificationCenter defaultCenter] removeObserver:Requestor name:notificationString object:nil];
	if ([notificationCenterDispatchList indexOfObject:notificationString]!=NSNotFound) {
		int i = [notificationCenterDispatchList indexOfObject:notificationString];
		[notificationCenterDispatchList removeObjectAtIndex:i];
		[notificationCenterDispatchListObservers removeObjectAtIndex:i];
		//NSLog(@"#2 Object %@ requested to remove Notification \"%@",Requestor, notificationString);

	}
	else {}//NSLog(@"Message Not Found");
}


- (void) removeAllNotificationObserversWithMessage: (NSString *) notificationString {
	int i = [notificationCenterDispatchList indexOfObject:notificationString];
	if (i!=NSNotFound) {
		[self removeNotificationRequestFrom:[notificationCenterDispatchListObservers objectAtIndex:i] WithMessage:notificationString];
	}
	else {}//NSLog(@"Message Not Found");
}

- (void) setActivityWindowContentTo: (int) content {
	[secondViewController setActivityWindowContentTo:content];
}

- (void) updateAvatarUsernameAndPasswordWith: (SettingsObject *) settings{
	[firstViewController updateAvatarUsernameAndPasswordWith:settings];
}
	
- (void)dealloc {
    [super dealloc];
}


@end
