//
//  SettingsObject.m
//  iSold_Apps
//
//  Created by Steve Sebban on 25/09/09.
//  Copyright 2009 KPL Production Services, Ltd.. All rights reserved.
//

#import "SettingsObject.h"


@implementation SettingsObject

@synthesize interfaceCurrency;
@synthesize userName;
@synthesize password;
@synthesize dateFormat;
@synthesize checkAtLaunch;
@synthesize keepOriginalRegionCurrency;
@synthesize validatedNamesAndPassword;

- (SettingsObject *) initWithUserName: (NSString *) name
							 password: (NSString *) pword
			validatedNamesAndPassword: (BOOL) validatedAccess
					interfaceCurrency: (NSString *) currency
							  dFormat: (int) format
						checkAtLaunch: (BOOL) checkAL
		   keepOriginalRegionCurrency: (BOOL) keepOriginalRC {
	
	[super init];
	if (name==nil) [self setUserName:@"missing"];
	else [self setUserName:name];
	
	if (pword==nil) [self setPassword:@"missing"];
	else [self setPassword:pword];
	
	if (validatedAccess!=0 && validatedAccess!=1) [self setValidatedNamesAndPassword:NO];
	else [self setValidatedNamesAndPassword:validatedAccess];
	
	if ([currency isEqualToString:@"default"] || currency==nil) [self setInterfaceCurrency:@"USD"];
	else [self setInterfaceCurrency:currency];
	
	if (format!=0 && format!=1) [self setDateFormat:0];
	else [self setDateFormat:format];
	
	if (checkAL!=0 && checkAL!=1) [self setCheckAtLaunch:1];
	else [self setCheckAtLaunch:checkAL];
		
	if (keepOriginalRC!=0 && keepOriginalRC!=1) [self setKeepOriginalRegionCurrency:1];
	else [self setKeepOriginalRegionCurrency:keepOriginalRC];
	
	return self;
	
}

- (NSString *)description {
	return [[NSString alloc] initWithFormat:@"\nUser Name = %@\nPassword = %@\nValidated Name and Password = %i\nCurrency = %@\nDate Format = %i\nCheck At Launch = %i\nKeep Original Region Currency = %i", userName, password, validatedNamesAndPassword, interfaceCurrency, dateFormat, checkAtLaunch, keepOriginalRegionCurrency];
}

@end
