//
//  SettingsViewController.h
//  iSold_Apps
//
//  Created by Steve Sebban on 26/09/09.
//  Copyright 2009 KPL Production Services, Ltd.. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "SettingsObject.h"
#import "SettingsPicker.h"
#import "AppsInfoUserAvatar.h"

@interface SettingsViewController : UIViewController <UITextFieldDelegate, UIActionSheetDelegate, UIAlertViewDelegate>{

	IBOutlet UITabBarController *tabBarController;
	IBOutlet UITextField *userNameField;
	IBOutlet UITextField *passwordField;
	IBOutlet UIButton *currentDateFormatButton;
	IBOutlet UIButton *currentCurrencyButton;
	IBOutlet UISwitch *checkAtLaunchSwitch;
	IBOutlet UISwitch *keepOriginalRegionCurrnecySwitch;
	IBOutlet UIView *activityWindow;
	IBOutlet UIImageView *validityMessage;
	IBOutlet UIImageView *endingSessionMessage;
	IBOutlet UIImageView *validationInProgressMessage;
	IBOutlet UIImageView *updatingCurrencyMessage;
	IBOutlet UIActivityIndicatorView *activityAnimation;
	IBOutlet UIButton *activityCancelButton;
	UILabel *statusLabel; //Fictive Object
	SettingsObject *userSettingsObject;
	NSDictionary *countriesAndCurrencies;

}

@property (nonatomic, retain) IBOutlet UITextField *userNameField;
@property (nonatomic, retain) IBOutlet UITextField *passwordField;
@property (nonatomic, retain) IBOutlet UIButton *currentDateFormatButton;
@property (nonatomic, retain) IBOutlet UIButton *currentCurrencyButton;
@property (nonatomic, retain) IBOutlet UISwitch *checkAtLaunchSwitch;
@property (nonatomic, retain) IBOutlet UISwitch *keepOriginalRegionCurrnecySwitch;
@property (nonatomic, assign) UILabel *statusLabel;
@property (readwrite, assign) SettingsObject *userSettingsObject;
@property (readwrite, assign) NSDictionary *countriesAndCurrencies;


- (BOOL) checkNetworkAvailibility;
- (IBAction) verificationOfAccessInfoCancelled: (id) sender;
- (IBAction) createCurrencyPicker: (id) sender;
- (IBAction) createDateFormatActionSheet: (id) sender;
- (IBAction) switchWasFlipped: (id) sender;
- (void) validateUserName: (NSString *) name andPassword: (NSString *) password;
- (NSDictionary *) countryNamesAndRegions;
- (void) addNotificationRequestFrom: (id) Requestor toOperate: (SEL) method WithMessage: (NSString *) notificationString;
- (void) removeNotificationRequestFrom: (id) Requestor WithMessage: (NSString *) notificationString;
- (BOOL) doesMessageExistInDispatchList: (NSString *) message;
- (void) setActivityWindowContentTo: (int) content;

@end
