//
//  SettingsViewController.m
//  iSold_Apps
//
//  Created by Steve Sebban on 26/09/09.
//  Copyright 2009 KPL Production Services, Ltd.. All rights reserved.
//

#import "SettingsViewController.h"


@implementation SettingsViewController

@synthesize userNameField;
@synthesize passwordField;
@synthesize currentDateFormatButton;
@synthesize currentCurrencyButton;
@synthesize checkAtLaunchSwitch;
@synthesize keepOriginalRegionCurrnecySwitch;
@synthesize statusLabel;
@synthesize userSettingsObject;
@synthesize countriesAndCurrencies;

NSFileManager *fileManager;
NSString *fileName, *directoryContents, *userNameBackupString, *passwordBackupString, *tempUserName, *tempPassword;
UIView *pickerView;
SettingsPicker *currencyPicker;
BOOL doesPickerExists = NO;
BOOL fieldsEditingEnded = YES;
NSArray *currencyList;
//AppsInfoUserAvatar *userAvatar;
NSTimer *myTimer;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/
#pragma mark Initiation of Objects

- (void) populateDailySalesViewWith: (NSArray *) dailySalesData {
	//dummy function
}


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	statusLabel = [[UILabel alloc] initWithFrame:CGRectZero];
	[userNameField setClearButtonMode:UITextFieldViewModeWhileEditing];
	[userNameField setClearsOnBeginEditing:NO];	
	[passwordField setClearButtonMode:UITextFieldViewModeWhileEditing];
	[passwordField setClearsOnBeginEditing:NO];		
}

#pragma mark getter Functions

- (void) addNotificationRequestFrom: (id) Requestor toOperate: (SEL) method WithMessage: (NSString *) notificationString {
	[tabBarController addNotificationRequestFrom: Requestor toOperate: method WithMessage:notificationString];
}

- (void) removeNotificationRequestFrom: (id) Requestor WithMessage: (NSString *) notificationString {
	[tabBarController removeNotificationRequestFrom: Requestor WithMessage: notificationString];
}

- (BOOL) doesMessageExistInDispatchList: (NSString *) message {
	if ([[tabBarController notificationCenterDispatchList] indexOfObject:message]==NSNotFound) return NO;
	else return YES;
}

#pragma mark Interface Updating

- (void) setSettingsInView {	
	[userNameField setText:[userSettingsObject userName]];
	[passwordField setText:[userSettingsObject password]];
	
	NSString *currentDateFormat = (userSettingsObject.dateFormat==0)?@"MM/DD/YY":@"DD/MM/YY";
	NSString *currentCurrency = [userSettingsObject interfaceCurrency];
	[currentDateFormatButton setTitle:currentDateFormat forState:UIControlStateNormal];
	[currentCurrencyButton setTitle:currentCurrency forState:UIControlStateNormal];
	
	switch ([userSettingsObject checkAtLaunch]) {
		case 0:
			[checkAtLaunchSwitch setOn:NO animated:NO];
			break;
		case 1:
			[checkAtLaunchSwitch setOn:YES animated:NO];
			break;
		default:
			break;
	}
	
	switch ([userSettingsObject keepOriginalRegionCurrency]) {
		case 0:
			[keepOriginalRegionCurrnecySwitch setOn:NO animated:NO];
			break;
		case 1:
			[keepOriginalRegionCurrnecySwitch setOn:YES animated:NO];
			break;
		default:
			break;
	}
}

- (IBAction) createCurrencyPicker: (id) sender {
	
	NSString *chosenCurrencyName;
	int indexOfSelectionInPicker;
	
	if ([userSettingsObject interfaceCurrency]!=nil) {
		int indexOfSelectionInDictionary = [[countriesAndCurrencies objectForKey:@"currencyCodes"] indexOfObject:[userSettingsObject interfaceCurrency]];
		chosenCurrencyName = [[countriesAndCurrencies objectForKey:@"currencyNames"] objectAtIndex:indexOfSelectionInDictionary];
		indexOfSelectionInPicker = [currencyList indexOfObject:chosenCurrencyName];
	}
	else {
		chosenCurrencyName = @"US Dollar";
		indexOfSelectionInPicker = [currencyList indexOfObject:chosenCurrencyName];
	}
	
	if (!doesPickerExists) {
		
		pickerView = [[UIView alloc] initWithFrame:CGRectMake(0.0, 415.0, 320.0, 216.0)];
		UIToolbar *pickerToolbar = [[UIToolbar alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 40.0)];
		[pickerToolbar setBarStyle:UIBarStyleBlackTranslucent];
		UIBarButtonItem *doneButton = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemDone target:self action:@selector(updateChosenCurrency)];
		UIBarButtonItem *spaceButton = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil];
		UIBarButtonItem *cancelButton = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemCancel target:self action:@selector(cancelCurrencyPicker)];
		NSArray *pickerToolbarItems = [[NSArray alloc] initWithObjects: cancelButton, spaceButton, doneButton, nil];
		[pickerToolbar setItems:pickerToolbarItems];
		
		currencyPicker = [[SettingsPicker alloc] initWithFrame:CGRectZero withArray:currencyList];
		[currencyPicker setFrame:CGRectMake(0.0f, 40.0f, 320.0f, 216.0f)];
		[currencyPicker selectRow:indexOfSelectionInPicker inComponent:0 animated:NO];
		
		[pickerView addSubview:pickerToolbar];
		[pickerView addSubview:currencyPicker];
		[[self view] addSubview:pickerView];
		doesPickerExists=YES;
		
		CGContextRef context = UIGraphicsGetCurrentContext();
		[UIView beginAnimations:nil context:context]; 
		[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut]; 
		[UIView setAnimationDuration:0.5]; 
		[pickerView setFrame:CGRectMake(0.0, 155.0, 320.0, 230.0)]; 
		[UIView commitAnimations];
	}
}

- (void) cancelCurrencyPicker {
	CGContextRef context = UIGraphicsGetCurrentContext();
	[UIView beginAnimations:nil context:context]; 
	[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut]; 
	[UIView setAnimationDuration:0.5]; 
	[pickerView setFrame:CGRectMake(0.0, 415.0, 320.0, 216.0)]; 
	[UIView commitAnimations]; 
	[self performSelector:@selector(removeAndReleasePickerView) withObject:nil afterDelay:0.5];
}

- (void) removeAndReleasePickerView {
	[pickerView removeFromSuperview];
	[pickerView release];
	doesPickerExists=NO;
	
}

- (void) updateChosenCurrency {
	if ([self checkNetworkAvailibility]) {
		//NSLog(@"updateChosenCurrency");
		int selectedRow = [currencyPicker selectedRowInComponent:0];
		int indexOfSelectionInDictionary = [[countriesAndCurrencies objectForKey:@"currencyNames"] indexOfObject:[currencyList objectAtIndex:selectedRow]];
		NSString *chosenCurrencyCode = [[countriesAndCurrencies objectForKey:@"currencyCodes"] objectAtIndex:indexOfSelectionInDictionary];
		[userSettingsObject setInterfaceCurrency:chosenCurrencyCode];
		[self saveUserSettings];
		[currentCurrencyButton setTitle:chosenCurrencyCode forState:UIControlStateNormal];
		[self cancelCurrencyPicker];
		if ([self doesMessageExistInDispatchList:@"Logout Completed"]) [tabBarController removeAllNotificationObserversWithMessage:@"Logout Completed"];
		//NSLog(@"tabBarController notificationCenterDispatchList = %@",[tabBarController notificationCenterDispatchList]);
		[self addNotificationRequestFrom:self toOperate:@selector(updateAllWithChosenCurrency) WithMessage:@"Logout Completed"];
		[tabBarController cancelLoginAvatarIfRunning];
	}
	else {}
}

- (void) updateAllWithChosenCurrency {
	//NSLog(@"updateAllWithChosenCurrency");
	[self removeNotificationRequestFrom:self WithMessage:@"Logout Completed"];
	[tabBarController setFirstViewUserSettingsObject:userSettingsObject];
	[tabBarController updateFirstView];
}

- (IBAction) createDateFormatActionSheet: (id) sender {
	UIActionSheet *dateFormatSheet = [[UIActionSheet alloc] initWithTitle:@"Choose Date Format" delegate:self cancelButtonTitle:@"Cancel" destructiveButtonTitle:nil otherButtonTitles:@"MM/DD/YY", @"DD/MM/YY", nil];
	[dateFormatSheet setActionSheetStyle:UIActionSheetStyleBlackTranslucent];
	[dateFormatSheet showInView:self.view];
}

- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
	if (buttonIndex!=[actionSheet numberOfButtons]-1) {
		[userSettingsObject setDateFormat:buttonIndex];
		[self saveUserSettings];
		[currentDateFormatButton setTitle:[actionSheet buttonTitleAtIndex:buttonIndex] forState:UIControlStateNormal];
		[tabBarController updateDataInView:@"Date"];
	}
}

- (void) setActivityWindowContentTo: (int) content {
	
	if ([activityWindow isDescendantOfView:[[self view] superview]]) {
		//NSLog(@"activityWindow exists!");
	}
	else {
		[[[self view] superview] addSubview:activityWindow];
		[activityWindow setFrame:CGRectMake(70.0, 150.0, activityWindow.frame.size.width, activityWindow.frame.size.height)];
		//NSLog(@"activityWindow created!");
	}
	
	switch (content) {
		case 0:
			[activityWindow setHidden:YES];
			[validityMessage setHidden:YES];
			[validationInProgressMessage setHidden:YES];
			[endingSessionMessage setHidden:YES];
			[updatingCurrencyMessage setHidden:YES];
			[activityAnimation setHidden:YES];
			[activityAnimation stopAnimating];
			[activityCancelButton setHidden:YES];
			break;
		case 1:
			[activityWindow setHidden:NO];
			[validityMessage setHidden:YES];
			[validationInProgressMessage setHidden:YES];
			[endingSessionMessage setHidden:NO];
			[updatingCurrencyMessage setHidden:YES];
			[activityAnimation setCenter:CGPointMake(95.0, 75.0)];
			[activityAnimation setHidden:NO];
			[activityAnimation startAnimating];
			[activityCancelButton setHidden:NO];
			[[self view] setUserInteractionEnabled:NO];
			[tabBarController isTabBarEnabled:NO];
			break;
		case 2:
			[activityWindow setHidden:NO];
			[validityMessage setHidden:YES];
			[validationInProgressMessage setHidden:NO];
			[endingSessionMessage setHidden:YES];
			[updatingCurrencyMessage setHidden:YES];
			[activityAnimation setCenter:CGPointMake(95.0, 75.0)];
			[activityAnimation setHidden:NO];
			[activityAnimation startAnimating];
			[activityCancelButton setHidden:NO];
			[[self view] setUserInteractionEnabled:NO];
			[tabBarController isTabBarEnabled:NO];
			break;
		case 3:
			[activityWindow setHidden:NO];
			[validityMessage setHidden:NO];
			[validationInProgressMessage setHidden:YES];
			[endingSessionMessage setHidden:YES];
			[updatingCurrencyMessage setHidden:YES];
			[activityAnimation setHidden:YES];
			[activityAnimation stopAnimating];
			[activityCancelButton setHidden:YES];
			[[self view] setUserInteractionEnabled:YES];
			[tabBarController isTabBarEnabled:YES];
			break;
		case 4:
			[activityWindow setHidden:NO];
			[validityMessage setHidden:YES];
			[validationInProgressMessage setHidden:YES];
			[endingSessionMessage setHidden:YES];
			[updatingCurrencyMessage setHidden:NO];
			[activityAnimation setCenter:CGPointMake(95.0, 100.0)];
			[activityAnimation setHidden:NO];
			[activityAnimation startAnimating];
			[activityCancelButton setHidden:YES];
			[[self view] setUserInteractionEnabled:YES];
			[tabBarController isTabBarEnabled:YES];
			break;
		default:
			break;
	}
	
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

#pragma mark Interaction Responses

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
	//NSLog(@"touchesBegan: withEvent:");
    // Dismiss the keyboard when the view outside the text field is touched.
	if ([userNameField isEditing]) {
		[userNameField resignFirstResponder];
		if ([self checkIfNameAndPasswordWereEntered]) {
			if ([self checkIfNewNameAndPasswordWereEntered]) [self verifyAccessInfo];
		}
	}
	else if ([passwordField isEditing]) {
		[passwordField resignFirstResponder];
		if ([self checkIfNameAndPasswordWereEntered]) {
			if ([self checkIfNewNameAndPasswordWereEntered]) [self verifyAccessInfo];
		}
	}
    [super touchesBegan:touches withEvent:event];
}

- (void)textFieldDidBeginEditing:(UITextField *)textField {
	if (fieldsEditingEnded) {
		fieldsEditingEnded = NO;
		tempUserName = [[NSString alloc] initWithString:[userNameField text]];
		tempPassword = [[NSString alloc] initWithString:[passwordField text]];
	}
}

- (BOOL)textFieldShouldClear:(UITextField *)textField {
	return YES;
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
	if ([userNameField isEditing]) {
		[textField resignFirstResponder];
		[passwordField becomeFirstResponder];
	}
	else if ([passwordField isEditing]) {
		[textField resignFirstResponder];
		if ([self checkIfNameAndPasswordWereEntered]) {
			if ([self checkIfNewNameAndPasswordWereEntered]) [self verifyAccessInfo];
		}
	}
		
	return YES;
}

- (BOOL) checkIfNameAndPasswordWereEntered {
	fieldsEditingEnded = YES;
	NSString *nameString = [[NSString alloc] initWithString:[userNameField text]];
	NSString *passwordString = [[NSString alloc] initWithString:[passwordField text]];
	nameString = [nameString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	passwordString = [passwordString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	BOOL wasNameStringEntered = ![nameString isEqualToString:@""];
	BOOL wasPasswordStringEntered = ![passwordString isEqualToString:@""];
	if (wasNameStringEntered && wasPasswordStringEntered) return YES;
	else return NO;
}

- (BOOL) checkIfNewNameAndPasswordWereEntered {
	//NSLog(@"checkIfNewNameAndPasswordWereEntered");
	NSString *nameString = [[NSString alloc] initWithString:[userNameField text]];
	NSString *passwordString = [[NSString alloc] initWithString:[passwordField text]];
	nameString = [nameString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	passwordString = [passwordString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	//NSLog(@"nameString = %@\ntempUserName = %@", nameString, tempUserName);
	BOOL wasNewNameStringEntered = ![nameString isEqualToString:tempUserName];
	BOOL wasNewPasswordStringEntered = ![passwordString isEqualToString:tempPassword];
	//NSLog(@"wasNewNameStringEntered: %@",wasNewNameStringEntered?@"YES":@"NO");
	//NSLog(@"wasNewPasswordStringEntered: %@",wasNewPasswordStringEntered?@"YES":@"NO");
	if (wasNewNameStringEntered || wasNewPasswordStringEntered) return YES;
	else return NO;
}

- (IBAction) switchWasFlipped: (id) sender {
	switch ([sender tag]) {
		case 0:
			[userSettingsObject setCheckAtLaunch:[sender isOn]];
			break;
		case 1:
			[userSettingsObject setKeepOriginalRegionCurrency:[sender isOn]];
			[tabBarController setFirstViewUserSettingsObject:userSettingsObject];
			break;
		default:
			break;
	}
	[self saveUserSettings];
}


#pragma mark Data Validation & Manipulation

- (BOOL) checkNetworkAvailibility {
	return [tabBarController checkNetworkAvailibility];	
}

- (void) verifyAccessInfo {
	//NSLog(@"notificationCenterDispatchList = %@",[tabBarController notificationCenterDispatchList]);
	if ([self checkNetworkAvailibility]) {
		if ([self checkIfNameAndPasswordWereEntered]) {
			BOOL doesUserAvatarExist = [tabBarController doesUserAvatarExistInFirstViewController];
			if (doesUserAvatarExist) {
				if ([self doesMessageExistInDispatchList:@"Logout Completed"]) [tabBarController removeAllNotificationObserversWithMessage:@"Logout Completed"];
				[self addNotificationRequestFrom:self toOperate:@selector(continueToVerifyAccessInfo) WithMessage:@"Logout Completed"];
				[self setActivityWindowContentTo:1];
				[tabBarController cancelLoginAvatarIfRunning];
			}
			else if (!doesUserAvatarExist) {
				[self continueToVerifyAccessInfo];
			}
		}
	}
	else {}
}

- (void) continueToVerifyAccessInfo {
	//NSLog(@"continueToVerifyAccessInfo");
	[self removeNotificationRequestFrom:self WithMessage:@"Logout Completed"];
	[self setActivityWindowContentTo:2];
	[self validateUserName:[userNameField text] andPassword:[passwordField text]];
}


- (IBAction) verificationOfAccessInfoCancelled: (id) sender {
	[self removeNotificationRequestFrom:self WithMessage:@"Logout Completed"];

	//if (userAvatar!=nil) [userAvatar cancelCurrentConnection];
	//[activityAnimation stopAnimating];
	//[self setActivityWindowContentTo:0];
	//[activityWindow removeFromSuperview];
	[[self view] setUserInteractionEnabled:YES];
	[tabBarController isTabBarEnabled:YES];
	@try {
		BOOL isString = [sender isEqualToString:@"Access Confirmed"];
	}
	@catch (NSException * e) {
		userSettingsObject = [self initialSettingsFileCheck];
		[tabBarController updateAvatarUsernameAndPasswordWith:userSettingsObject];
		[tabBarController cancelButtonPressed:sender];
	}
	@finally {
	}

}


- (void) clearNotificationTextAndBringRefreshBarToFront {
}
/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
	
}
*/

- (void) validateUserName: (NSString *) name andPassword: (NSString *) codeword {
	//userNameBackupString = [[NSString alloc] initWithString:[userSettingsObject userName]];
	//passwordBackupString = [[NSString alloc] initWithString:[userSettingsObject password]];
	[userSettingsObject setUserName:name];
	[userSettingsObject setPassword:codeword];
	[tabBarController validateLoginDetailsWithName: name andPassword: codeword];

}


- (void) validationResult: (BOOL *) accessConfirmed {
	if (accessConfirmed) {
		[self setActivityWindowContentTo:3];
		[self performSelector:@selector(setActivityWindowContentTo:) withObject:(int)0 afterDelay:1.0];
		[self verificationOfAccessInfoCancelled:@"Access Confirmed"];
		[userSettingsObject setValidatedNamesAndPassword:YES];
		[self saveUserSettings];
	}
	else if (!accessConfirmed) {
		userSettingsObject = [self initialSettingsFileCheck];
		[tabBarController updateAvatarUsernameAndPasswordWith:userSettingsObject];
		[activityWindow setHidden:YES];
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Identification Failed" message:@"Please check your\nusername & password" delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[self verificationOfAccessInfoCancelled:nil];
		[alert release];
	}
}

- (void) createCurrencyArray: (NSArray *)fullArray {
	NSArray *sortedFullArray = [fullArray sortedArrayUsingSelector:@selector(localizedCaseInsensitiveCompare:)];
	NSMutableArray *sortedArray = [[NSMutableArray alloc] initWithArray:sortedFullArray];
	for (int i=1; i<[sortedArray count];i++) {
		if ([[sortedArray objectAtIndex:i] isEqualToString:[sortedArray objectAtIndex:i-1]]) {
			[sortedArray removeObjectAtIndex:i-1];
			i--;
		}
	}
	currencyList = [[NSArray alloc] initWithArray:sortedArray];
}

- (NSDictionary *) countryNamesAndRegions {
	return nil;
}

#pragma mark File Write & Read Functions

- (SettingsObject *) initialSettingsFileCheck {

	
	fileManager = [NSFileManager defaultManager];
	fileName = [[NSString alloc] initWithString:@"UserSettings.plist"];
	directoryContents = [[NSString alloc] initWithFormat:@"%@/Documents/%@",NSHomeDirectory(),fileName]; 
	
	SettingsObject *userSettingsObjectFromFile = nil;
	
	if (![fileManager fileExistsAtPath: directoryContents]) {
		[fileManager createFileAtPath:directoryContents contents:nil attributes:nil];
	}
	else {
		NSArray *data = [[NSArray alloc] initWithArray:[self readRecentUserSettingsFromFile]];
		userSettingsObjectFromFile = [[SettingsObject alloc] initWithUserName:[data objectAtIndex:0] 
																	 password:[data objectAtIndex:1] 
													validatedNamesAndPassword:[[data objectAtIndex:6] intValue] 
															interfaceCurrency:[data objectAtIndex:2] 
																	  dFormat:[[data objectAtIndex:3] intValue] 
																checkAtLaunch:[[data objectAtIndex:4] intValue] 
												   keepOriginalRegionCurrency:[[data objectAtIndex:5] intValue]];

	}

	return userSettingsObjectFromFile;
}

- (void) saveUserSettings {
	
	NSArray *userSettingsArray = [[NSArray alloc] initWithObjects:[userSettingsObject userName],[userSettingsObject password],[userSettingsObject interfaceCurrency],[[NSNumber alloc] initWithInt:[userSettingsObject dateFormat]], [[NSNumber alloc] initWithInt:[userSettingsObject checkAtLaunch]], [[NSNumber alloc] initWithInt:[userSettingsObject keepOriginalRegionCurrency]], [[NSNumber alloc] initWithInt:[userSettingsObject validatedNamesAndPassword]], nil];
	NSString *error;
	NSData *xmlData = [NSPropertyListSerialization dataFromPropertyList:userSettingsArray format:NSPropertyListXMLFormat_v1_0 errorDescription:&error]; 
	[xmlData writeToFile:directoryContents atomically:YES];	
}

- (NSData *) readRecentUserSettingsFromFile {
	
	NSData *data = [NSData dataWithContentsOfFile:directoryContents];
	id plist;
	NSString *error;
	NSPropertyListFormat format;
	plist = [NSPropertyListSerialization propertyListFromData:data mutabilityOption:NSPropertyListImmutable format:&format errorDescription:&error];
	if(!plist)
	{
		[error release];
	}
	return plist;
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)dealloc {
    [super dealloc];
}


@end
