//
//  currencyObject.m
//  iSold_Apps
//
//  Created by Steve Sebban on 05/04/10.
//  Copyright 2010 KPL Production Services, Ltd. All rights reserved.
//

#import "currencyObject.h"


@implementation currencyObject

NSDictionary *currencySymbols;
NSDictionary *currencyPerRegion;

-(currencyObject *) init {
	[super init];
	NSArray *currencySymbolObjects = [[NSArray alloc] initWithObjects:@"$",@"€",@"₪",@"£",@"¥",nil];
	NSArray *currencySymbolKeys = [[NSArray alloc] initWithObjects:@"USD",@"EUR",@"ILS",@"GBP",@"JPY",nil];
	currencySymbols = [[NSDictionary alloc] initWithObjects:currencySymbolObjects forKeys:currencySymbolKeys];
	return self;
}



- (NSString *) getCurrencyFormatFor: (NSString *) currency {
	if (currency==nil || [currency isEqualToString:@""]) {
		return @"";
	}
	else if ([currencySymbols objectForKey:currency]!=nil) {
		return [currencySymbols objectForKey:currency];
	}
	else {
		return currency;
	}	
}

- (NSString *) getCurrencyFormatForRegion: (NSString *) region {
	NSArray *currencySymbolPerRegionObjects = [[NSArray alloc] initWithObjects:@"AUD",@"CAD",@"€",@"¥",@"£",@"$",@"$",nil];
	NSArray *regionKeys = [[NSArray alloc] initWithObjects:@"Australia",@"Canada",@"Europe",@"Japan",@"United Kingdom",@"United States",@"Worldwide",nil];
	currencyPerRegion = [[NSDictionary alloc] initWithObjects:currencySymbolPerRegionObjects forKeys:regionKeys];
	return [currencyPerRegion objectForKey:region];
}
	
@end
